SystemOrganization addCategory: #OLE!

TextMorph subclass: #AnswerViewMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

TextMorph subclass: #GameLevel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!GameLevel methodsFor: 'as yet unclassified' stamp: 'lg 10/8/2007 17:10'!
isGameLevel
	^true! !

TextMorph subclass: #GameTextMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!GameTextMorph methodsFor: 'game value' stamp: 'lg 10/1/2007 16:34'!
getGameValue
	^self getNumericValue.! !

!GameTextMorph methodsFor: 'game value' stamp: 'lg 10/1/2007 16:08'!
increment
	self setNumericValue: self getNumericValue + 1.! !

!GameTextMorph methodsFor: 'as yet unclassified' stamp: 'lg 10/1/2007 15:25'!
isGameInput
	^true! !

!GameTextMorph methodsFor: 'game value' stamp: 'lg 10/1/2007 16:08'!
setGameValue: n 
	self setNumericValue: n.! !

GameTextMorph subclass: #ScoreTextMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

ScoreTextMorph subclass: #MistakesTextMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!MistakesTextMorph methodsFor: 'as yet unclassified' stamp: 'lg 10/3/2007 12:47'!
isGameMistakes
	^true! !

!MistakesTextMorph methodsFor: 'as yet unclassified' stamp: 'lg 10/3/2007 12:47'!
isGameScore
	^false! !

!ScoreTextMorph methodsFor: 'as yet unclassified' stamp: 'lg 10/2/2007 16:37'!
isGameInput
	^false! !

!ScoreTextMorph methodsFor: 'as yet unclassified' stamp: 'lg 10/2/2007 16:52'!
isGameScore
	^true! !

TextMorph subclass: #MyNepaliText
	instanceVariableNames: 'maxLength'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!MyNepaliText class methodsFor: 'as yet unclassified' stamp: 'Ram 1/18/2008 14:57'!
newWithMaxLength: aNumber
	| model |
	model:= self basicNew.
	model maxLength: aNumber.
	model initialize.
	^model	! !

!MyNepaliText methodsFor: 'as yet unclassified' stamp: 'Ram 1/25/2008 10:42'!
acceptText
	self fontName: #DevanagariNew size: 50! !

!MyNepaliText methodsFor: 'as yet unclassified' stamp: 'Ram 1/18/2008 14:58'!
defaultText: aString  fontIndexOfPointSize: aNumber

	| style index |
	text:= Text fromString:aString.
	style:=TextStyle named:'DevanagariNew'.
	index:= style fontIndexOfPointSize: aNumber.
	text addAttribute:(TextFontChange fontNumber: index).
	^text! !

!MyNepaliText methodsFor: 'as yet unclassified' stamp: 'Ram 1/18/2008 14:56'!
handleKeystroke: anEvent
	"System level event handling. Avoid Tab Handling, This was done to avoid variableDocks problem"

	anEvent wasHandled ifTrue:[^self].
	(self handlesKeyboard: anEvent) ifFalse:	[^ self].
	anEvent wasHandled: true.
	anEvent keyCharacter = Character tab ifTrue:[^self].
	self keyStroke: anEvent! !

!MyNepaliText methodsFor: 'as yet unclassified' stamp: 'Ram 1/25/2008 10:38'!
initialize
	super initialize.
	"Don't wrap the contents"
	text:= self defaultText: 'ram' fontIndexOfPointSize:30.
	
	self contentsWrapped:text;
		backgroundColor: Color white;
		borderWidth:1;
		autoFit: false;
		crAction: (MessageSend receiver: self selector: #acceptText).
	self setFontStyle.
	self maxLength ifNil:[self maxLength:5]! !

!MyNepaliText methodsFor: 'as yet unclassified' stamp: 'Ram 1/18/2008 17:39'!
keyStroke: evt
	super keyStroke: evt.
	(super elementCount>= (self maxLength+1))ifTrue:[self contents:  ((self contents)asString truncateTo: (self maxLength)).
		evt hand newKeyboardFocus: self.
		self handleInteraction: [editor mouseDown: evt] fromEvent: evt.
	].
	! !

!MyNepaliText methodsFor: 'as yet unclassified' stamp: 'Ram 1/18/2008 14:57'!
maxLength
	"Answer the value of maxLength"

	^ maxLength	
	! !

!MyNepaliText methodsFor: 'as yet unclassified' stamp: 'Ram 1/18/2008 14:57'!
maxLength: anObject
	"Set the value of maxLength"

	maxLength _ anObject! !

!MyNepaliText methodsFor: 'as yet unclassified' stamp: 'Ram 1/21/2008 12:14'!
setDefaultText
	| defaultText |
	defaultText:= self defaultText:'??' fontIndexOfPointSize:30.
	self setCharacters: defaultText
	! !

!MyNepaliText methodsFor: 'as yet unclassified' stamp: 'Ram 1/18/2008 15:04'!
setFontStyle
	| style |
	style:=TextStyle named:'DevanagariNew'.
	self setTextStyle:style.! !

TextMorph subclass: #MyText
	instanceVariableNames: 'maxLength'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!MyText class methodsFor: 'as yet unclassified' stamp: 'Ram 1/3/2008 14:58'!
newWithMaxLength: aNumber
	| model |
	model:= self basicNew.
	model maxLength: aNumber.
	model initialize.
	^model! !

!MyText methodsFor: 'as yet unclassified' stamp: 'Ram 1/21/2008 13:17'!
acceptText
! !

!MyText methodsFor: 'accessing' stamp: 'Ram 1/3/2008 14:55'!
defaultText: aString  fontIndexOfPointSize: aNumber

	| baseFont style index |
	text:= Text fromString:aString.
	baseFont:=Preferences standardEToysFont.
	style:=baseFont textStyle.
	index:= style fontIndexOfPointSize: aNumber.
	text addAttribute:(TextFontChange fontNumber: index).
	^text! !

!MyText methodsFor: 'event handling' stamp: 'Ram 3/18/2008 13:01'!
handleKeystroke: anEvent
	"System level event handling. Avoid Tab Handling, This was done to avoid variableDocks problem"

	anEvent wasHandled ifTrue:[^self].
	(self handlesKeyboard: anEvent) ifFalse:	[^ self].
	anEvent wasHandled: true.
	"anEvent keyCharacter = Character tab ifTrue:[^self]."
	self keyStroke: anEvent! !

!MyText methodsFor: 'initialization' stamp: 'Ram 1/3/2008 15:14'!
initialize
	super initialize.
	"Don't wrap the contents"
	text:= self defaultText: 'Ram' fontIndexOfPointSize:24.
	
	self contentsWrapped:text;
		backgroundColor: Color white;
		borderWidth:1;
		autoFit: false;
		crAction: (MessageSend receiver: self selector: #acceptText).
	self setFontStyle.
	self maxLength ifNil:[self maxLength:5]! !

!MyText methodsFor: 'event handling' stamp: 'Ram 3/18/2008 13:03'!
keyStroke: evt

	super keyStroke: evt.
	(super elementCount>= (self maxLength+1))ifTrue:[self contents:  ((self contents)asString truncateTo: (self maxLength)).
		evt hand newKeyboardFocus: self.
		self handleInteraction: [editor mouseDown: evt] fromEvent: evt.
	].

! !

!MyText methodsFor: 'accessing' stamp: 'Ram 1/3/2008 14:56'!
maxLength
	"Answer the value of maxLength"

	^ maxLength! !

!MyText methodsFor: 'accessing' stamp: 'Ram 1/3/2008 14:56'!
maxLength: anObject
	"Set the value of maxLength"

	maxLength _ anObject
	! !

!MyText methodsFor: 'accessing' stamp: 'Ram 1/3/2008 14:55'!
setFontStyle
	| baseFont style |
	baseFont:=Preferences standardEToysFont.
	style:=baseFont textStyle.
	self setTextStyle:style.! !

!TextMorph methodsFor: '*ole-game' stamp: 'lg 10/29/2007 15:36'!
gameValue
	^self getCharacters asNumber.! !

!TextMorph methodsFor: '*ole-game' stamp: 'lg 10/29/2007 15:33'!
gameValue: value
	self contents: value asString.! !

RectangleMorph subclass: #FootBallGame
	instanceVariableNames: 'answerList soundList GameLevel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!FootBallGame methodsFor: 'accessing' stamp: 'Ram 3/27/2008 12:24'!
answerList
	"Answer the value of answerList"

	^ answerList! !

!FootBallGame methodsFor: 'accessing' stamp: 'Ram 3/27/2008 12:24'!
answerList: anObject
	"Set the value of answerList"

	answerList _ anObject! !

!FootBallGame methodsFor: 'accessing' stamp: 'Ram 3/27/2008 12:26'!
GameLevel
	"Answer the value of GameLevel"

	^ GameLevel! !

!FootBallGame methodsFor: 'accessing' stamp: 'Ram 3/27/2008 12:26'!
GameLevel: anObject
	"Set the value of GameLevel"

	GameLevel _ anObject! !

!FootBallGame methodsFor: 'as yet unclassified' stamp: 'Ram 3/27/2008 12:28'!
loadAnswer
	self gameLevel =1 
	ifTrue:[
		self answerList: #('its a red book' 'she  is a girl' 'There is an apple' 'Its ink' 'its only three oClock' 'He is a boy' 'We see two oranges' 
			'The book is blue' 'Its four oClock' ).	]
	ifFalse:[
		self answerList: #('He is sleeping' 'That is a red door' 'It has a tail' 'Its got wheels' 'Its an insect' 'Rain is falling' 'The window is open' 
			'He has got a cap' 'They are friends' ).
	]! !

!FootBallGame methodsFor: 'as yet unclassified' stamp: 'Ram 3/27/2008 12:30'!
loadSound
	self gameLevel =1 
	ifTrue:[
		self soundList: #('itsRedbook' 'sheGirl' 'theresApple' 'itsInk' 'its3Oclock' 'heBoy' 'weOranges' 'bookBlue' 'its4Oclock')	]
	ifFalse:[
		self soundList: #('heIsSleeping' 'thatsRedDoor' 'itHasATail' 'itsGotsWheel' 'itsInsect' 'itsRaining' 'theWindowsIsOpen' 'heIsWearingACap' 'theyAreFriends' ).
	]! !

!FootBallGame methodsFor: 'accessing' stamp: 'Ram 3/27/2008 12:24'!
soundList
	"Answer the value of soundList"

	^ soundList! !

!FootBallGame methodsFor: 'accessing' stamp: 'Ram 3/27/2008 12:24'!
soundList: anObject
	"Set the value of soundList"

	soundList _ anObject! !

RectangleMorph subclass: #MemoryTile
	instanceVariableNames: 'textBox picture showText'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!MemoryTile methodsFor: 'as yet unclassified' stamp: ''!
getAlpha
	^ self renderedMorph color alpha * 100! !

!MemoryTile methodsFor: 'initialization' stamp: ''!
initialize
	super initialize.
	self width: 125.
	self height: 125.
	self
		color: (Color
				r: 0.613
				g: 0.903
				b: 1.0).
	self showText: true.
	self initTextBox.
	self initPicture! !

!MemoryTile methodsFor: 'initialization' stamp: 'Aayush 4/11/2008 10:26'!
initPicture
	self picture: ImageMorph new.
	self picture center: self center.
	self addMorph: self picture.
	self picture hide! !

!MemoryTile methodsFor: 'initialization' stamp: 'Aayush 4/11/2008 00:58'!
initTextBox
	| |
	self textBox: StringMorph new.
	self textBox fontName: 'BitstreamVeraSans' size: 36.
	self textBox contents: 'Test'.
	self textBox lock.
	self addMorph: self textBox.

"	
	x := 2 random.
	x = 1
		ifTrue: [self textBox heading: -45]
		ifFalse: [self textBox heading: 45]

	self textBox heading: -45.
"! !

!MemoryTile methodsFor: 'accessing - properties' stamp: ''!
picture
	^ picture! !

!MemoryTile methodsFor: 'accessing - properties' stamp: ''!
picture: anImage 
	picture := anImage! !

!MemoryTile methodsFor: 'as yet unclassified' stamp: 'Aayush 4/9/2008 15:09'!
setAlpha: aFloat 
	| aMorph aValue aColor |
	aMorph := self renderedMorph.
	(aColor := aMorph color) isColor
		ifTrue: 
		[
			aValue := (aFloat / 100 max: 0) min: 1.
			aMorph
				color: (Color
						r: aColor red
						g: aColor green
						b: aColor blue
						alpha: aValue)
		]! !

!MemoryTile methodsFor: 'accessing - properties' stamp: ''!
showText
	^ showText! !

!MemoryTile methodsFor: 'accessing - properties' stamp: ''!
showText: aBoolean 
	showText := aBoolean! !

!MemoryTile methodsFor: 'as yet unclassified' stamp: ''!
stepTime
	^ 10! !

!MemoryTile methodsFor: 'as yet unclassified' stamp: 'Aayush 4/14/2008 17:10'!
step
	self getAlpha > 0
	ifTrue: 
	[
		self setAlpha: self getAlpha - 10
	]
	ifFalse: 
	[
		self stopStepping.
		self setAlpha: 100.
		
		self showText = true ifTrue: 
		[
			self textBox visible = true ifTrue: 
			[
				self textBox hide.
				(self owner) noOfTilesOpen > 0 ifTrue:
				[
					(self owner) noOfTilesOpen: (self owner) noOfTilesOpen -1.
					(self owner) noOfTilesOpen = 0 ifTrue:
					[
						(self owner) processTileClickEvent: true.
						(self owner) currentOpen:0.
						(self owner) previousOpen:0.
					]
				]
			]
			ifFalse: 
			[
				self textBox show.
				(self owner) noOfTilesOpen = 1 ifTrue:
				[
					(self owner) processTileClickEvent: true.
				]
			]
		]
		ifFalse: 
		[
			(self picture) visible = true ifTrue: 
			[
				(self picture) hide.
				(self owner) noOfTilesOpen > 0 ifTrue:
				[
					(self owner) noOfTilesOpen: (self owner) noOfTilesOpen -1.
					(self owner) noOfTilesOpen = 0 ifTrue:
					[
						(self owner) processTileClickEvent: true.
						(self owner) currentOpen:0.
						(self owner) previousOpen:0.
					]
				]
			]
			ifFalse: 
			[
				(self picture) show.
				(self owner) noOfTilesOpen = 1 ifTrue:
				[
					(self owner) processTileClickEvent: true.
				]
			]
		].
		
		(self owner) noOfTilesOpen = 2 ifTrue:
		[
			World displayWorldSafely.
			(Delay forMilliseconds: 800) wait.
			(self owner) checkAnswer = true ifTrue:
			[				
				(self owner) processTileClickEvent: true.

				(self owner) pairMatched: (self owner) pairMatched + 1.
				(self owner) pairMatched = 15 ifTrue:
				[
					(self owner) gameRunning: false.
					(self owner) timer player timeUp.
				].

				((self owner) magicStarIndex = (self owner) currentOpen or: [ (self owner) magicStarIndex = (self owner) 				previousOpen]) ifTrue:
				[
					(self owner) showingAll: true.
					(self owner) showAll.
					(self owner) processTileClickEvent:false.
				].

				( (self owner) tiles at: ((self owner) currentOpen) ) hide.
				( (self owner) tiles at: ((self owner) previousOpen) ) hide.
				(self owner) currentOpen:0.
				(self owner) previousOpen:0.
				(self owner) noOfTilesOpen:0.
			]
			ifFalse:
			[
				( (self owner) tiles at: ((self owner) currentOpen) ) startStepping.
				( (self owner) tiles at: ((self owner) previousOpen) ) startStepping.
				(self owner) currentOpen:0.
				(self owner) previousOpen:0.
			]
		]
	]! !

!MemoryTile methodsFor: 'accessing - properties' stamp: ''!
textBox
	^ textBox! !

!MemoryTile methodsFor: 'accessing - properties' stamp: ''!
textBox: aUserText 
	textBox := aUserText! !

RectangleMorph subclass: #MyPicWordExt
	instanceVariableNames: 'questionList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!MyPicWordExt methodsFor: 'accessing' stamp: 'Ram 1/31/2008 17:50'!
addMajorQuesion: questionWithSound minor: aQuestion
	| p1 |
	p1:= Dictionary new.
	p1 at:'major' put: questionWithSound.
	p1 at:'minor' put: aQuestion.
	questionList add: p1.
^ self! !

!MyPicWordExt methodsFor: 'initialization' stamp: 'Ram 1/31/2008 17:09'!
initialize
	super initialize.
	questionList:= OrderedCollection new.! !

!MyPicWordExt methodsFor: 'accessing' stamp: 'Ram 1/31/2008 17:09'!
majorQuestionAt: aIndex
	
	| question majorQuestion |
	question:= questionList at: aIndex.
	majorQuestion:= question at: 'major'.
	^majorQuestion! !

!MyPicWordExt methodsFor: 'accessing' stamp: 'Ram 1/31/2008 17:10'!
minorQuestionAt: aIndex
	
	| question minorQuestion |
	question:= questionList at: aIndex.
	minorQuestion:= question at: 'minor'.
	^minorQuestion! !

!MyPicWordExt methodsFor: 'as yet unclassified' stamp: 'Ram 1/31/2008 17:09'!
prepareQuesion
	questionList:= OrderedCollection new.
	! !

!MyPicWordExt methodsFor: 'accessing' stamp: 'Ram 1/31/2008 17:08'!
questionList
	"Answer the value of questionList"

	^ questionList! !

!MyPicWordExt methodsFor: 'accessing' stamp: 'Ram 1/31/2008 17:08'!
questionList: anObject
	"Set the value of questionList"

	questionList _ anObject! !

RectangleMorph subclass: #NumberGame
	instanceVariableNames: 'minValue maxSum minSum haveMadeMistake score total level difficulty lastAnswer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

NumberGame subclass: #MultiplyGame
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!NumberGame class methodsFor: 'game' stamp: 'lg 10/1/2007 16:29'!
answer: n 
	World allMorphsDo: [ :m | (m isKindOf: self) ifTrue: [m answer: n]].
! !

!NumberGame class methodsFor: 'game' stamp: 'lg 10/12/2007 12:50'!
beginGame
	World allMorphsDo: [ :m | (m isKindOf: NumberGame) ifTrue: [m beginGame] ].! !

!NumberGame methodsFor: 'game' stamp: 'lg 10/14/2007 14:42'!
answer: n
	lastAnswer := n.
	n = self getGameValue ifTrue: [self win: n] ifFalse: [self lose].
! !

!NumberGame methodsFor: 'as yet unclassified' stamp: 'lg 12/24/2007 09:58'!
beginGame
	ActiveWorld cleanUpReferences.
	World allMorphsDo: [ :m | (m isKindOf: ObjectSetMorph) ifTrue: [m resetObjectSequence]].
	self setLevel: 1.
	self setScore: 0.
	World selectMorphs: #isGameChoice do: #show.
	self setTotal: -1. "XXX cheesy"
	self newGame.! !

!NumberGame methodsFor: 'as yet unclassified' stamp: 'lg 10/11/2007 13:10'!
chooseObject
	World allMorphsDo: [ :m | (m isKindOf: ObjectSetMorph) ifTrue: [m installNewTallyMorph ]].! !

!NumberGame methodsFor: 'as yet unclassified' stamp: 'lg 10/11/2007 13:38'!
difficulty: d
	difficulty := d.! !

!NumberGame methodsFor: 'game' stamp: 'lg 10/14/2007 14:34'!
displayAnswer: n
	[ World selectKind: AnswerViewMorph do: [ :m | m contents: n asString. m show. (Delay forSeconds: 2) wait ]] fork.! !

!NumberGame methodsFor: 'as yet unclassified' stamp: 'lg 12/5/2007 12:08'!
displayMood: mood
	"["GameFeedbackMorph showState: mood.
	 (mood = #happy) ifTrue: [World selectKind: AnswerViewMorph do: [:m | m contents: lastAnswer asString; show]].
	World doOneCycleNow.
	 (Delay forSeconds: 2) wait.
	 GameFeedbackMorph showState: #neutral.
	 World selectKind: AnswerViewMorph do: #hide
! !

!NumberGame methodsFor: 'game' stamp: 'lg 10/14/2007 18:19'!
endGame
	self beep: 'byebye'.
	World selectMorphs: #isGameChoice do: #hide.
	World selectMorphs: #isGameInput do: [ :m | m setGameValue: 0 ].! !

!NumberGame methodsFor: 'as yet unclassified' stamp: 'lg 10/2/2007 15:33'!
gameChoices
	^World allMorphs select: #isGameChoice.! !

!NumberGame methodsFor: 'as yet unclassified' stamp: 'lg 10/1/2007 15:30'!
gameInputs
	^World allMorphs select: #isGameInput.! !

!NumberGame methodsFor: 'game' stamp: 'lg 10/1/2007 16:34'!
getGameValue
	^(self gameInputs collect: #getGameValue) sum.! !

!NumberGame methodsFor: 'game' stamp: 'lg 10/8/2007 17:06'!
increaseInputs
	| used seed |
	used := minValue * self gameInputs size.
	seed := ((minSum to: maxSum) - used) atRandom.
	seed timesRepeat: [ self gameInputs atRandom increment ].
! !

!NumberGame methodsFor: 'as yet unclassified' stamp: 'lg 10/9/2007 09:07'!
initialize
	super initialize.
	self beginGame.! !

!NumberGame methodsFor: 'game' stamp: 'lg 10/14/2007 14:45'!
lose
	self beep: 'wrong3'. self displayMood: #sad; mistake.! !

!NumberGame methodsFor: 'game' stamp: 'lg 10/13/2007 14:03'!
mistake
	haveMadeMistake := true.
! !

!NumberGame methodsFor: 'as yet unclassified' stamp: 'lg 10/13/2007 14:02'!
newGame
	haveMadeMistake := false.
	self setTotal: total + 1; resetInputs; increaseInputs; updateChoices.
! !

!NumberGame methodsFor: 'game' stamp: 'lg 10/1/2007 16:15'!
resetInputs
	self gameInputs do: [ :input | input setGameValue: minValue ].
! !

!NumberGame methodsFor: 'game' stamp: 'lg 10/13/2007 12:55'!
score
	self setScore: score + 1.
	(score \\ 10) = 0 ifTrue: [self setLevel: 1 + (score / 10)].
! !

!NumberGame methodsFor: 'as yet unclassified' stamp: 'lg 10/11/2007 13:33'!
setLevel: n
	level := n.
	World selectMorphs: #isGameLevel do: [:morph | morph contents: level asString].
	self chooseObject.
	difficulty = #easy
		ifTrue:
		[n = 1 ifTrue: [minValue := 1. minSum :=2. maxSum := 4].
		 n = 2 ifTrue: [minValue := 1. minSum := 2. maxSum := 6].
		 n = 3 ifTrue: [minValue := 1. minSum := 2. maxSum := 8].
		 n = 4 ifTrue: [minValue := 0. minSum := 2. maxSum := 9].
		 n > 4 ifTrue: [self endGame] ]
		ifFalse:
		[n = 1 ifTrue: [minValue := 1. minSum := 2. maxSum := 6].
		 n = 2 ifTrue: [minValue := 0. minSum := 0. maxSum := 9].
		 n = 3 ifTrue: [minValue := 0. minSum := 9. maxSum := 15].
		 n = 4 ifTrue: [minValue := 0. minSum := 12. maxSum := 20].
		 n > 4 ifTrue: [self endGame] ].

! !

!NumberGame methodsFor: 'game' stamp: 'lg 10/13/2007 12:55'!
setScore: n
	score := n.
	World selectMorphs: #isGameScore do: [ :morph | morph setGameValue: score].
! !

!NumberGame methodsFor: 'game' stamp: 'lg 10/13/2007 13:52'!
setTotal: n
	total := n.
	World selectMorphs: #isGameTotal do: [ :morph | morph setGameValue: score].
! !

!NumberGame methodsFor: 'game' stamp: 'lg 10/2/2007 15:33'!
updateChoices
	| choices correct answers results stream |
	choices := self gameChoices.
	correct := self getGameValue.
	answers := (minValue to: maxSum) asArray shuffled reject: [ :x | x == correct]. 
	stream := answers readStream.
	results := OrderedCollection new.
	(choices size - 1) timesRepeat: [ results add: stream next ].
	results add: correct.
	results := results shuffled.
	stream := results readStream.
	choices do: [ :choice | choice setGameValue: stream next ].! !

!NumberGame methodsFor: 'game' stamp: 'lg 10/14/2007 18:57'!
win: n
	((n < 22) or: [n = 77]) ifTrue: [self beep: n asString] ifFalse: [self beep: 'right1'].
	self displayAnswer: n.
	haveMadeMistake ifFalse: [self score].
	self displayMood: #happy.
	self newGame.
! !

NumberGame subclass: #QuestionNumberGame
	instanceVariableNames: 'questions question'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!QuestionNumberGame class methodsFor: 'game' stamp: 'lg 10/14/2007 16:01'!
readQuestion
	World selectKind: self do: #readQuestion.! !

!QuestionNumberGame methodsFor: 'as yet unclassified' stamp: 'lg 10/14/2007 14:00'!
answer
	^question valueOfProperty: #answer.! !

!QuestionNumberGame methodsFor: 'as yet unclassified' stamp: 'lg 10/14/2007 08:19'!
beginGame
	questions := (World allMorphs detect: [ :m | m isKindOf: QuestionSetMorph ]) questions.
	super beginGame.
! !

!QuestionNumberGame methodsFor: 'as yet unclassified' stamp: 'lg 10/14/2007 14:04'!
getGameValue
	^self answer.! !

!QuestionNumberGame methodsFor: 'as yet unclassified' stamp: 'lg 10/14/2007 17:59'!
newGame
	total := total + 1.
	question ifNotNil: [question delete].
	questions atEnd ifTrue: [ ^self endGame ].
	question := questions next.
	World addMorph: question.
	question position: 75@125.
	question lock.
	haveMadeMistake := false.
	self setupChoicesForQuestion.! !

!QuestionNumberGame methodsFor: 'game' stamp: 'lg 10/14/2007 16:04'!
readQuestion
	self beep: (question valueOfProperty: #questionSound).! !

!QuestionNumberGame methodsFor: 'as yet unclassified' stamp: 'lg 10/14/2007 10:32'!
setupChoicesForQuestion
	| choices answers rightAnswer |
	choices := self gameChoices shuffled readStream.
	choices atEnd ifTrue: [^self].
	rightAnswer := question valueOfProperty: #answer.
	answers := ((rightAnswer // 2 to: rightAnswer * 2) asOrderedCollection remove: rightAnswer; yourself) shuffled readStream.
	choices next setGameValue: rightAnswer.
	[choices atEnd] whileFalse: [ choices next setGameValue: answers next ].! !

RectangleMorph subclass: #ObjectiveQuestionGame
	instanceVariableNames: 'objectiveQuestionList gameTitle question'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!ObjectiveQuestionGame methodsFor: 'as yet unclassified' stamp: 'Ram 3/30/2008 12:30'!
addQuestion: aQuestion

	objectiveQuestionList add: aQuestion.! !

!ObjectiveQuestionGame methodsFor: 'as yet unclassified' stamp: 'Ram 3/30/2008 16:54'!
answerAt: aIndex
	^question correctAns! !

!ObjectiveQuestionGame methodsFor: 'as yet unclassified' stamp: 'Ram 3/30/2008 12:30'!
clearQuestionList
	objectiveQuestionList := OrderedCollection new.! !

!ObjectiveQuestionGame methodsFor: 'accessing' stamp: 'Ram 3/30/2008 12:31'!
gameTitle
	"Answer the value of gameTitle"

	^ gameTitle! !

!ObjectiveQuestionGame methodsFor: 'accessing' stamp: 'Ram 3/30/2008 12:31'!
gameTitle: anObject
	"Set the value of gameTitle"

	gameTitle _ anObject! !

!ObjectiveQuestionGame methodsFor: 'accessing' stamp: 'Ram 3/30/2008 12:28'!
objectiveQuestionList
	"Answer the value of objectiveQuestionList"

	^ objectiveQuestionList! !

!ObjectiveQuestionGame methodsFor: 'accessing' stamp: 'Ram 3/30/2008 12:28'!
objectiveQuestionList: anObject
	"Set the value of objectiveQuestionList"

	objectiveQuestionList _ anObject! !

!ObjectiveQuestionGame methodsFor: 'as yet unclassified' stamp: 'Ram 3/30/2008 15:25'!
questionAt: aIndex
	 question:=(objectiveQuestionList at: aIndex asInteger).
	^question! !

!ObjectiveQuestionGame methodsFor: 'as yet unclassified' stamp: 'Ram 3/31/2008 12:44'!
questionOptionSize
	 ^question isNil ifFalse:[ question optionList size].
! !

!ObjectiveQuestionGame methodsFor: 'as yet unclassified' stamp: 'Ram 3/30/2008 12:38'!
questionOption
	 ^question isNil ifFalse:[ question optionList].
! !

!ObjectiveQuestionGame methodsFor: 'as yet unclassified' stamp: 'Ram 3/30/2008 15:03'!
totalQuestion
	^objectiveQuestionList size.! !

RectangleMorph subclass: #OleActionVerb
	instanceVariableNames: 'verbList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!OleActionVerb methodsFor: 'as yet unclassified' stamp: 'Ram 3/19/2008 11:16'!
addVerb: verb
	verbList add: verb.! !

!OleActionVerb methodsFor: 'as yet unclassified' stamp: 'Ram 3/19/2008 11:44'!
clearVerbList
	verbList:= OrderedCollection new! !

!OleActionVerb methodsFor: 'as yet unclassified' stamp: 'Ram 3/19/2008 11:16'!
verbAt: aIndex
	^verbList at: aIndex! !

!OleActionVerb methodsFor: 'accessing' stamp: 'Ram 3/19/2008 11:14'!
verbList
	"Answer the value of verbList"

	^ verbList! !

!OleActionVerb methodsFor: 'accessing' stamp: 'Ram 3/19/2008 11:14'!
verbList: anObject
	"Set the value of verbList"

	verbList _ anObject! !

RectangleMorph subclass: #SetsGame
	instanceVariableNames: 'currentStage colDisplayGrid inputSensor answer answerStage1 imgQusNo1 imgQusNo2 displayGrid displayGridP gridHeadingR gridHeadingC gridValueC gridValueR cellValue currentQuestion ansDisplay qusDisplay qusNoDisplay btnNext imgQusNoId ansSelected moveImgQusNo2 questionSet qusRemainInSet imgRowInfo imgColInfo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!SetsGame methodsFor: 'miscellaneous' stamp: 'A 5/27/2008 12:33'!
addAns
	[self qusRemainInSet size > 0] whileTrue:
	[
		(self qusRemainInSet) removeAt:1	
	].

"--------------------1--------------------"
	(self answer) add: 'DMFS'.
	(self answer) add: 'LMFS'.
	(self answer) add: 'SBMFS'.
	(self answer) add: 'DMIS'.
	(self answer) add: 'LMIS'.
	(self answer) add: 'SBMIS'.
	(self answer) add: 'DMNS'.
	(self answer) add: 'LMNS'.
	(self answer) add: 'SBMNS'.
"--------------------2--------------------"
	(self answer) add: 'LMFS'.
	(self answer) add: 'LMIS'.
	(self answer) add: 'LMNS'.
	(self answer) add: 'DMIS'.
	(self answer) add: 'DMFS'.
	(self answer) add: 'DMNS'.
	(self answer) add: 'SBMIS'.
	(self answer) add: 'SBMFS'.
	(self answer) add: 'SBMNS'.
"--------------------3--------------------"
	(self answer) add: 'DMFS'.
	(self answer) add: 'LMFS'.
	(self answer) add: 'SBMFS'.
	(self answer) add: 'DMIS'.
	(self answer) add: 'LMIS'.
	(self answer) add: 'SBMIS'.
	(self answer) add: 'DMNS'.
	(self answer) add: 'LMNS'.
	(self answer) add: 'SBMNS'.
"--------------------4--------------------"
	(self answer) add: 'DMFS'.
	(self answer) add: 'LMFS'.
	(self answer) add: 'SBMFS'.
	(self answer) add: 'DMIS'.
	(self answer) add: 'LMIS'.
	(self answer) add: 'SBMIS'.
	(self answer) add: 'DMNS'.
	(self answer) add: 'LMNS'.
	(self answer) add: 'SBMNS'.
"--------------------5--------------------"
	(self answer) add: 'DMFS'.
	(self answer) add: 'LMFS'.
	(self answer) add: 'SBMFS'.
	(self answer) add: 'DMIS'.
	(self answer) add: 'LMIS'.
	(self answer) add: 'SBMIS'.
	(self answer) add: 'DMNS'.
	(self answer) add: 'LMNS'.
	(self answer) add: 'SBMNS'.
! !

!SetsGame methodsFor: 'Accessing - Properties' stamp: 'Aayush 5/23/2008 10:30'!
ansDisplay
	^ansDisplay! !

!SetsGame methodsFor: 'Accessing - Properties' stamp: 'Aayush 5/23/2008 10:30'!
ansDisplay: anImageMorph
	ansDisplay:= anImageMorph! !

!SetsGame methodsFor: 'Accessing - Properties' stamp: 'Aayush 5/23/2008 13:12'!
ansSelected
	^ansSelected! !

!SetsGame methodsFor: 'Accessing - Properties' stamp: 'Aayush 5/23/2008 13:13'!
ansSelected: aMatrix
	ansSelected:= aMatrix! !

!SetsGame methodsFor: 'Accessing - Properties' stamp: 'Aayush 5/19/2008 03:05'!
answer
	^answer! !

!SetsGame methodsFor: 'Accessing - Properties' stamp: 'Aayush 5/19/2008 03:05'!
answer: anArray
	answer := anArray! !

!SetsGame methodsFor: 'Accessing - Properties' stamp: 'Aayush 5/23/2008 12:44'!
btnNext
	^btnNext! !

!SetsGame methodsFor: 'Accessing - Properties' stamp: 'Aayush 5/23/2008 12:44'!
btnNext: anImageMorph
	btnNext:= anImageMorph.! !

!SetsGame methodsFor: 'Accessing - Properties' stamp: 'Aayush 5/19/2008 03:18'!
cellValue
	^cellValue! !

!SetsGame methodsFor: 'Accessing - Properties' stamp: 'Aayush 5/19/2008 03:18'!
cellValue: aString
	cellValue := aString! !

!SetsGame methodsFor: 'Question-Generation' stamp: 'Aayush 6/3/2008 15:37'!
changeColRowInfoImage
	| tCenter |
	tCenter:= self imgColInfo center.
	(self imgColInfo) center: (self imgRowInfo) center.
	(self imgRowInfo) center: tCenter.
! !

!SetsGame methodsFor: 'Question-Generation' stamp: 'Aayush 6/3/2008 15:38'!
changeHeadingImage
	| t1 x count |

	self swapGridValue.
	self randGridValuePosition.
	t1 := 'Heading-'.
	World
		allMorphsDo: [:t2 | ((t2 isKindOf: SketchMorph)
					and: [t2 externalName asString beginsWith: t1])
				ifTrue: [
		x := (t2 externalName asString) subStrings:'-'.
		x := x at:2.

		count := 2.
		[
			(self gridValueR at:count) = x ifTrue:
			[
				(self gridHeadingR at:(count-1)) wearCostume: t2.
				(self gridHeadingR at:(count-1)) center: (self displayGrid at:count at:1) center.
			]
			ifFalse:
			[
				(self gridValueC at:count) = x ifTrue:
				[
					(self gridHeadingC at:(count-1)) wearCostume: t2.
					(self gridHeadingC at:(count-1)) center: (self displayGrid at:1 at:count) center.
				]
			].
			count := count +1.
			count <=4.				
		]whileTrue.
]].

self changeColRowInfoImage.! !

!SetsGame methodsFor: 'Question-Generation' stamp: 'Aayush 5/26/2008 10:56'!
changeQuestionImage: qusNo
	| t1 t3 |
	self currentStage = 2 ifTrue:
	[
		t1 := 'question-'.
		t3 := t1,(qusNo asString).
		World
			allMorphsDo: [:t2 | ((t2 isKindOf: SketchMorph)
						and: [t2 externalName asString sameAs: t3])
					ifTrue: [
								(self qusDisplay dispImage) wearCostume: t2.
								(self qusDisplay dispImage) center: (self qusDisplay center).
							]
			]
	]
	ifFalse:
	[
		t1 := 'discription-'.
		t3 := t1,(qusNo asString).
		World
			allMorphsDo: [:t2 | ((t2 isKindOf: SketchMorph)
						and: [t2 externalName asString sameAs: t3])
					ifTrue: [
								(self qusDisplay dispImage) wearCostume: t2.
								(self qusDisplay dispImage) center: (self qusDisplay center).
							]
			]
	]! !

!SetsGame methodsFor: 'Question-Generation' stamp: 'Aayush 5/29/2008 09:57'!
changeQusNoImage: qusNo
	| t1 t3 |
	self currentStage = 2 ifTrue:
	[
		t1 := 'circle-'.
		t3 := t1,(qusNo asString).
		World
			allMorphsDo: [:t2 | ((t2 isKindOf: SketchMorph)
						and: [t2 externalName asString sameAs: t3])
					ifTrue: [
								((self qusNoDisplay) dispImage) wearCostume: t2.
								((self qusNoDisplay) dispImage) center: ((self qusNoDisplay) center).
								self imgQusNo2 wearCostume: t2.
								self imgQusNo2 center:((self qusNoDisplay) dispImage) center.
							]
		]
	]
	ifFalse:
	[
		t1 := 'discCellPos-'.
		t3 := t1,(qusNo asString).
		World
			allMorphsDo: [:t2 | ((t2 isKindOf: SketchMorph)
						and: [t2 externalName asString sameAs: t3])
					ifTrue: [
								((self qusNoDisplay) dispImage) wearCostume: t2.
								((self qusNoDisplay) dispImage) center: ((self qusNoDisplay) center).
								self imgQusNo2 wearCostume: t2.
								self imgQusNo2 center:((self qusNoDisplay) dispImage) center.
							]
		]
	]! !

!SetsGame methodsFor: 'Question-Generation' stamp: 'Aayush 5/19/2008 10:05'!
checkAnswer
	| arr x y z1 z2 ans |
	arr := self cellValue subStrings: ':'.
	x := arr at:1.
	y := arr at:2.
	z1 := x,y.
	z2 := y,x.
	ans := self answer at: self currentQuestion.

	( ans  = z1  or: [ ans = z2] ) ifTrue:
	[
		^true.
	]
	ifFalse:
	[
		^false.
	].	
! !

!SetsGame methodsFor: 'Accessing - Properties' stamp: 'Aayush 5/18/2008 09:19'!
colDisplayGrid
	^colDisplayGrid! !

!SetsGame methodsFor: 'Accessing - Properties' stamp: 'Aayush 5/18/2008 09:43'!
colDisplayGrid: aColor
	colDisplayGrid:=aColor! !

!SetsGame methodsFor: 'Accessing - Properties' stamp: 'a 5/16/2008 15:04'!
currentQuestion
	^currentQuestion! !

!SetsGame methodsFor: 'Accessing - Properties' stamp: 'a 5/16/2008 15:04'!
currentQuestion: aNumber
	currentQuestion := aNumber! !

!SetsGame methodsFor: 'Accessing - Properties' stamp: 'Aayush 5/26/2008 10:41'!
currentStage
	^currentStage! !

!SetsGame methodsFor: 'Accessing - Properties' stamp: 'Aayush 5/26/2008 10:42'!
currentStage: aNumber
	currentStage:= aNumber! !

!SetsGame methodsFor: 'Accessing - Properties' stamp: 'Aayush 5/22/2008 11:36'!
displayGridP
	^displayGridP! !

!SetsGame methodsFor: 'Accessing - Properties' stamp: 'Aayush 5/22/2008 11:37'!
displayGridP: aMatrix
	displayGridP:= aMatrix! !

!SetsGame methodsFor: 'Accessing - Properties' stamp: 'a 5/15/2008 16:52'!
displayGrid
	^displayGrid! !

!SetsGame methodsFor: 'Accessing - Properties' stamp: 'a 5/15/2008 16:53'!
displayGrid: aMatrix
	displayGrid := aMatrix! !

!SetsGame methodsFor: 'Display-Grid' stamp: 'Aayush 5/19/2008 09:38'!
getCellValueRow:r Col:c
	self cellValue: (self gridValueR at:r),':', (self gridValueC at:c).

! !

!SetsGame methodsFor: 'Accessing - Properties' stamp: 'Aayush 5/19/2008 03:25'!
gridHeadingC
	^gridHeadingC! !

!SetsGame methodsFor: 'Accessing - Properties' stamp: 'Aayush 5/19/2008 03:27'!
gridHeadingC: anArray
	gridHeadingC :=  anArray! !

!SetsGame methodsFor: 'Accessing - Properties' stamp: 'Aayush 5/19/2008 03:28'!
gridHeadingR
	^gridHeadingR! !

!SetsGame methodsFor: 'Accessing - Properties' stamp: 'Aayush 5/19/2008 03:28'!
gridHeadingR: anArray
	gridHeadingR :=  anArray! !

!SetsGame methodsFor: 'Accessing - Properties' stamp: 'Aayush 5/19/2008 03:28'!
gridValueC
	^gridValueC! !

!SetsGame methodsFor: 'Accessing - Properties' stamp: 'Aayush 5/19/2008 03:29'!
gridValueC: anArray
	gridValueC:= anArray! !

!SetsGame methodsFor: 'Accessing - Properties' stamp: 'Aayush 5/19/2008 03:29'!
gridValueR
	^gridValueR! !

!SetsGame methodsFor: 'Accessing - Properties' stamp: 'Aayush 5/19/2008 03:30'!
gridValueR: anArray
	gridValueR:= anArray! !

!SetsGame methodsFor: 'miscellaneous' stamp: 'Aayush 5/23/2008 11:19'!
hideAnsSelected
	self ansDisplay hide.
! !

!SetsGame methodsFor: 'Display-Grid' stamp: 'Aayush 5/22/2008 15:40'!
hideAnswer
	| row col |
	row:=1.
	[
		col:=1.
		[
			(self displayGridP at:row at: col) hide.
			col := col +1.
			col <=3.
		]whileTrue.	

		row := row + 1.
		row <=3
	]whileTrue.

! !

!SetsGame methodsFor: 'Display-Grid' stamp: 'Aayush 5/29/2008 12:07'!
highLightDisplayGridRow:r Col:c
	| col row |
	col := 1.
	[
		(self displayGrid at:r at:col) color: (Color r:0.6 g:0.7 b:0.8). 
		col := col + 1.
		col <= 4
	]whileTrue.

	row := 1.
	[
		(self displayGrid at:row at:c) color: (Color r:0.6 g:0.7 b:0.8). 
		row := row + 1.
		row <= 4
	]whileTrue.

	(self displayGrid at:r at:c) color: (Color r:0.5 g:0.6 b:0.7). 
! !

!SetsGame methodsFor: 'Accessing - Properties' stamp: 'Aayush 6/3/2008 14:16'!
imgColInfo
	^imgColInfo! !

!SetsGame methodsFor: 'Accessing - Properties' stamp: 'Aayush 6/3/2008 14:16'!
imgColInfo: aImageMorph
	imgColInfo:= aImageMorph! !

!SetsGame methodsFor: 'Accessing - Properties' stamp: 'Aayush 5/19/2008 03:55'!
imgQusNo1
	^imgQusNo1! !

!SetsGame methodsFor: 'Accessing - Properties' stamp: 'Aayush 5/19/2008 03:56'!
imgQusNo1: anImageMorph
	imgQusNo1:=anImageMorph! !

!SetsGame methodsFor: 'Accessing - Properties' stamp: 'Aayush 5/19/2008 03:55'!
imgQusNo2
	^imgQusNo2! !

!SetsGame methodsFor: 'Accessing - Properties' stamp: 'Aayush 5/19/2008 03:56'!
imgQusNo2: anImageMorph
	imgQusNo2:=anImageMorph! !

!SetsGame methodsFor: 'Accessing - Properties' stamp: 'Aayush 5/23/2008 12:59'!
imgQusNoId
	^imgQusNoId! !

!SetsGame methodsFor: 'Accessing - Properties' stamp: 'Aayush 5/23/2008 12:59'!
imgQusNoId: aNumber
	imgQusNoId:=aNumber! !

!SetsGame methodsFor: 'Accessing - Properties' stamp: 'Aayush 6/3/2008 14:15'!
imgRowInfo
	^imgRowInfo! !

!SetsGame methodsFor: 'Accessing - Properties' stamp: 'Aayush 6/3/2008 14:16'!
imgRowInfo: aImageMorph
	imgRowInfo:= aImageMorph! !

!SetsGame methodsFor: 'Initialization' stamp: 'A 5/27/2008 12:51'!
initAnswer
	self answer: OrderedCollection new.
	self addAns.
	self ansSelected: (Matrix rows:4 columns:4).

! !

!SetsGame methodsFor: 'Initialization' stamp: 'Aayush 6/3/2008 14:39'!
initCostume
	| t1 |
	t1 := 'box'.
	World allMorphsDo: 
	[	
		:t2 | ((t2 isKindOf: SketchMorph) and: [t2 externalName asString sameAs: t1])				
		ifTrue:
	 	[
			self qusDisplay wearCostume: t2.
			self ansDisplay wearCostume: t2.
		]
	].

	t1 := 'box-small'.
	World allMorphsDo: 
	[	
		:t2 | ((t2 isKindOf: SketchMorph) and: [t2 externalName asString sameAs: t1])				
		ifTrue:
	 	[
			(self qusNoDisplay) wearCostume: t2.
		]
	].

	t1 := 'type'.
	World allMorphsDo: 
	[	
		:t2 | ((t2 isKindOf: SketchMorph) and: [t2 externalName asString sameAs: t1])				
		ifTrue:
	 	[
			(self imgRowInfo) wearCostume: t2.
		]
	].

	t1 := 'method'.
	World allMorphsDo: 
	[	
		:t2 | ((t2 isKindOf: SketchMorph) and: [t2 externalName asString sameAs: t1])				
		ifTrue:
	 	[
			(self imgColInfo) wearCostume: t2.
		]
	].

	t1 := 'btn_next'.
	World allMorphsDo: 
	[	
		:t2 | ((t2 isKindOf: SketchMorph) and: [t2 externalName asString sameAs: t1])				
		ifTrue:
	 	[
			self btnNext wearCostume: t2.
		]
	].

	self changeQuestionImage:1.
	self changeQusNoImage:1.
	self changeHeadingImage.

! !

!SetsGame methodsFor: 'Initialization' stamp: 'Aayush 5/23/2008 11:30'!
initDisplayGridP
	| col row |
	self displayGridP: (Matrix rows:3 columns:3).
	row := 1.
	[
		col := 1.
		[
			(self displayGridP) at:row at:col put: (ImageMorph new).	
			((self displayGridP) at:row at:col) on:#mouseEnter send:#showAnsSelected:V2:V3: to:self withValue:((row+1) asString, '-', (col+1) asString).
			((self displayGridP) at:row at:col) on:#mouseLeave send:#hideAnsSelected to:self.
			((self displayGridP) at:row at:col) openInWorld.
			((self displayGridP) at:row at:col) hide.
			self addMorph: ((self displayGridP) at:row at:col).	
			((self displayGridP) at:row at:col) center: (self displayGrid at:(row+1) at:(col+1)) center.

			col := col + 1.
			col <= 3.
		]whileTrue.		

		row := row + 1.	
		row <= 3
	]whileTrue.
! !

!SetsGame methodsFor: 'Initialization' stamp: 'A 5/26/2008 15:35'!
initDisplayGrid
	| row col x y |
	x := 0.
	y := 0.
	self displayGrid: (Matrix rows:4 columns:4).

	row := 1.
	[
		col := 1.
		[
			(row =1 and: [ col = 1]) ifFalse:
			[			
				(self displayGrid) at:row at:col put: (RectangleMorph new).	
				((self displayGrid) at:row at:col) width: 200.
				((self displayGrid) at:row at:col) height: 100.
				((self displayGrid) at:row at:col) left:x.
				((self displayGrid) at:row at:col) top:y.
				self addMorph: ((self displayGrid) at:row at:col).	
			].
			x  := x + 200.
			col := col + 1.
			col <= 4.
		]whileTrue.		

		x := 0.
		y := y + 100.
		row := row + 1.	
		row <= 4
	]whileTrue.
! !

!SetsGame methodsFor: 'Initialization' stamp: 'Aayush 5/19/2008 03:31'!
initGridHeading
	| count |
	self gridHeadingR: (Array new:3).	
	self gridHeadingC: (Array new:3).	
	count := 1.
	[
		(self gridHeadingR) at:count put:(ImageMorph new).
		self addMorph: ((self gridHeadingR) at:count).
		((self gridHeadingR) at:count) center: (self displayGrid at:(count + 1) at:1) center.

		(self gridHeadingC) at:count put:(ImageMorph new).
		self addMorph: ((self gridHeadingC) at:count).
		((self gridHeadingC) at:count ) center: (self displayGrid at:1 at:(count + 1)) center.

		count := count + 1.
		count <= 3.
	]whileTrue.
! !

!SetsGame methodsFor: 'Initialization' stamp: 'Aayush 5/19/2008 12:11'!
initGridValue
	self gridValueR: (Array withAll: #('empty' 'DM' 'LM' 'SBM')).
	self gridValueC: (Array withAll: #('empty' 'FS' 'IS' 'NS')).

	! !

!SetsGame methodsFor: 'Initialization' stamp: 'Aayush 6/3/2008 14:20'!
initImgColRowInfo
	self imgColInfo: ImageMorph new.
	self imgRowInfo: ImageMorph new.
	self addMorph:(self imgRowInfo).
	self addMorph:(self imgColInfo).
! !

!SetsGame methodsFor: 'Initialization' stamp: 'Aayush 6/3/2008 14:36'!
initialize
	super initialize.
	self inputSensor: InputSensor new.
	self width:800.
	self height:400.
	self color: (Color r:0.5 g:0.5 b:0.5).
	self initDisplayGrid.
	self initDisplayGridP.
	self initGridHeading.
	self initImgColRowInfo.
	self qusRemainInSet: (OrderedCollection new).

	self colDisplayGrid: (self displayGrid at:2 at:2) color.
	
	self initGridValue.
	self initAnswer.

	self initQusImage.
	self reset.

! !

!SetsGame methodsFor: 'Initialization' stamp: 'Aayush 5/29/2008 09:41'!
initQusImage
	self qusDisplay: DisplayBoard new.
	self qusDisplay openInWorld.
	self qusDisplay left:300.
	self qusDisplay top:500.

	self qusNoDisplay: DisplayBoard new.
	self qusNoDisplay openInWorld.
	self qusNoDisplay left:0.
	self qusNoDisplay top:500.
	
	self ansDisplay: DisplayBoard new.
	self ansDisplay openInWorld.
	self ansDisplay left:800.
	self ansDisplay top:300.
	self ansDisplay hide.

	self btnNext: ImageMorph new.
	self btnNext on:#mouseDown send:#nextClick to:self.
	self btnNext openInWorld.
	self btnNext left:800.
	self btnNext top:700.
	self btnNext hide.

	self imgQusNo2: ImageMorph new.
	self imgQusNo2 openInWorld.
	self imgQusNo2 comeToFront.
	self imgQusNo2 left:0.
	self imgQusNo2 top:500.
	self imgQusNo2 on:#mouseUp send:#toggleMoveImgQusNo2 to:self.
! !

!SetsGame methodsFor: 'Initialization' stamp: 'A 5/27/2008 10:49'!
initQusRemainInSet: setNumber

	| count x siz |

	x := (setNumber*9)-8.
	siz :=(self qusRemainInSet) size.
	siz > 0 ifTrue:
	[
		[
			self qusRemainInSet removeAt:1.
			siz :=(self qusRemainInSet) size.

			siz > 0
		]whileTrue.
	].

	count:= 1.
	[
		self qusRemainInSet add:x.
		x := x + 1.

		count := count + 1.
		count <= 9
	]whileTrue.

	! !

!SetsGame methodsFor: 'Accessing - Properties' stamp: 'a 5/16/2008 17:19'!
inputSensor
	^inputSensor! !

!SetsGame methodsFor: 'Accessing - Properties' stamp: 'a 5/16/2008 17:19'!
inputSensor: aninputSensor
	inputSensor := aninputSensor! !

!SetsGame methodsFor: 'Accessing - Properties' stamp: 'A 5/26/2008 15:25'!
moveImgQusNo2
	^moveImgQusNo2! !

!SetsGame methodsFor: 'Accessing - Properties' stamp: 'A 5/26/2008 15:26'!
moveImgQusNo2: aBoolean
	moveImgQusNo2:=aBoolean! !

!SetsGame methodsFor: 'miscellaneous' stamp: 'Aayush 5/29/2008 11:15'!
nextClick
	| y q |
	self btnNext hide.
	self changeHeadingImage.
	self hideAnswer.
	self imgQusNo2 show.
	self qusDisplay show.
	self qusNoDisplay show.


	self currentStage = 1 ifTrue:
	[
		self currentStage: self currentStage + 1.
		self imgQusNoId:1.
		self questionSet: 1.
	]
	ifFalse:
	[
		self questionSet: self questionSet + 1.
		self questionSet > 5 ifTrue:
		[
			self imgQusNoId:1.
			self questionSet: 1.
		]
	].
	self initQusRemainInSet: self questionSet.


	y := ((self qusRemainInSet) size) random.
	q := (self qusRemainInSet) at:y.
	self currentQuestion:q.

	self changeQuestionImage:q.
	(self qusRemainInSet) removeAt:y.

	self changeQusNoImage:self imgQusNoId.
! !

!SetsGame methodsFor: 'Accessing - Properties' stamp: 'A 5/26/2008 16:44'!
questionSet
	^questionSet! !

!SetsGame methodsFor: 'Accessing - Properties' stamp: 'A 5/26/2008 16:45'!
questionSet: aNumber
	questionSet:= aNumber! !

!SetsGame methodsFor: 'Accessing - Properties' stamp: 'Aayush 5/23/2008 10:30'!
qusDisplay
	^qusDisplay! !

!SetsGame methodsFor: 'Accessing - Properties' stamp: 'Aayush 5/23/2008 10:30'!
qusDisplay: anImageMorph
	qusDisplay:= anImageMorph! !

!SetsGame methodsFor: 'Accessing - Properties' stamp: 'Aayush 5/29/2008 09:38'!
qusNoDisplay
	^qusNoDisplay! !

!SetsGame methodsFor: 'Accessing - Properties' stamp: 'Aayush 5/29/2008 09:38'!
qusNoDisplay: aDispalyBoard
	qusNoDisplay := aDispalyBoard.! !

!SetsGame methodsFor: 'Accessing - Properties' stamp: 'A 5/26/2008 16:49'!
qusRemainInSet
	^qusRemainInSet
! !

!SetsGame methodsFor: 'Accessing - Properties' stamp: 'A 5/26/2008 16:50'!
qusRemainInSet: aList
	qusRemainInSet:= aList.
! !

!SetsGame methodsFor: 'Question-Generation' stamp: 'Aayush 5/22/2008 13:53'!
randGridValuePosition
	| count tmpArr1 tmpArr2 list1 list2 x1 y1 x2 y2 |

	tmpArr1 := Array new:3.
	tmpArr2 := Array new:3.

	list1 := OrderedCollection new.
	list1 addAll: #(1 2 3).

	list2 := OrderedCollection new.
	list2 addAll: #(1 2 3).

	count:=2.
	[
		x1 := (list1 size) random.
		y1 := list1 at:x1.
		tmpArr1 at:y1 put: (self gridValueR at:count). 
		list1 removeAt:x1.

		x2 := (list2 size) random.
		y2 := list2 at:x2.
		tmpArr2 at:y2 put: (self gridValueC at:count). 
		list2 removeAt:x2.

		count := count + 1.
		count <=4
	]whileTrue.

	count:=2.
	[
		self gridValueR at:count put: (tmpArr1 at:(count-1)).
		self gridValueC at:count put: (tmpArr2 at:(count-1)).

		count := count +1.
		count <=4
	]whileTrue.
! !

!SetsGame methodsFor: 'Display-Grid' stamp: 'Aayush 5/18/2008 09:40'!
resetDisplayGridColor
	| row col |
	row := 1.
	[	
		col := 1.
		[
			(row = 1 and: [ col= 1]) ifFalse:
			[
				(self displayGrid at:row at:col) color: (self colDisplayGrid).
			].

			col := col + 1.
			col <= 4
		]whileTrue.

		row := row + 1.
		row <= 4
	]whileTrue.
! !

!SetsGame methodsFor: 'Initialization' stamp: 'A 5/27/2008 10:58'!
reset
	| |
	self currentQuestion: 1.
	self imgQusNoId:1.
	self currentStage:1.
	self moveImgQusNo2:0.
	self questionSet:1.
	self initQusRemainInSet:1.
	self qusRemainInSet removeAt:1.
	self btnNext hide.

	self cellValue: ''.
	self hideAnswer.	
	self initCostume.
! !

!SetsGame methodsFor: 'miscellaneous' stamp: 'A 5/26/2008 14:15'!
showAnsSelected:x V2:y V3:z
	| arr row col t1 |
	self currentStage = 2 ifTrue:
	[
		arr:= x subStrings: '-'.
		row:=(arr at:1) asInteger.
		col:=(arr at:2) asInteger.

		t1 := 'question-', (self ansSelected at:row at:col) asString.
		World allMorphsDo: 
		[	
			:t2 | ((t2 isKindOf: SketchMorph) and: [t2 externalName asString sameAs: t1])				
			ifTrue:
	 		[
				((self ansDisplay) dispImage) wearCostume: t2.
			]
		].

		(self ansDisplay) center: (self displayGrid at:row at:col) center.
		((self ansDisplay) dispImage) center: (self ansDisplay) center.

		self ansDisplay top: self ansDisplay top + 150.
		self ansDisplay show.
		self ansDisplay comeToFront.
	]
	ifFalse:
	[
		arr:= x subStrings: '-'.
		row:=(arr at:1) asInteger.
		col:=(arr at:2) asInteger.

		t1 := 'discription-', (self ansSelected at:row at:col) asString.
		World allMorphsDo: 
		[	
			:t2 | ((t2 isKindOf: SketchMorph) and: [t2 externalName asString sameAs: t1])				
			ifTrue:
	 		[
				((self ansDisplay) dispImage) wearCostume: t2.
			]
		].

		(self ansDisplay) center: (self displayGrid at:row at:col) center.
		((self ansDisplay) dispImage) center: (self ansDisplay) center.

		self ansDisplay top: self ansDisplay top + 115.
		self ansDisplay show.
		self ansDisplay comeToFront.
	]
! !

!SetsGame methodsFor: 'miscellaneous' stamp: 'Aayush 5/22/2008 16:18'!
stepTime
	^250.
! !

!SetsGame methodsFor: 'miscellaneous' stamp: 'Aayush 5/29/2008 12:16'!
step
	| row col none y q |

	none := true.
	row := 2.
	[	
		col := 2.
		[
			((self inputSensor cursorPoint) > (((self displayGrid at:row at:col) topLeft) + (30@11)) 
			and: [ (self inputSensor cursorPoint) < (((self displayGrid at:row at:col) bottomRight) + (30@11)) ]) ifTrue:
			[
				self resetDisplayGridColor.
				self highLightDisplayGridRow:row Col:col.
				self getCellValueRow:row Col:col.
				none := false.
			
				self moveImgQusNo2 = 2 ifTrue:
				[
					self moveImgQusNo2:0. 

					self checkAnswer ifTrue:
					[
						SoundService default playSoundNamedOrBeep: 'right1'.

						self imgQusNo2 center: ((self qusNoDisplay) dispImage) center.
						(self displayGridP at:(row-1) at:(col-1)) wearCostume: self imgQusNo2.
						(self displayGridP at:(row-1) at:(col-1)) center: (self displayGrid at:row at:col) center.		
						(self displayGridP at:(row-1) at:(col-1)) show.

						self ansSelected at:row at:col put:(self currentQuestion).
	
						self imgQusNoId: self imgQusNoId + 1.
						self imgQusNoId > 9 ifTrue:
						[
							self imgQusNoId:1.
							self btnNext show.
							self imgQusNo2 hide.
							self qusDisplay hide.
							self qusNoDisplay hide.
						]
						ifFalse:
						[	
							y := ((self qusRemainInSet) size) random.
							q := (self qusRemainInSet) at:y.
							self currentQuestion:q.

							self changeQuestionImage:q.
							(self qusRemainInSet) removeAt:y.

							self currentStage = 2 ifTrue:
							[
								self changeQusNoImage:self imgQusNoId.
							]
							ifFalse:
							[
								self changeQusNoImage:q.
							]
						]
					]
					ifFalse:
					[
						SoundService default playSoundNamedOrBeep: 'wrong3'.
					]
				].
			].


			col := col + 1.
			col <= 4
		]whileTrue.

		row := row + 1.
		row <= 4
	]whileTrue.	

	none = true ifTrue:
	[
		self resetDisplayGridColor.
		self cellValue: ''.
	].

	self moveImgQusNo2 = 1 ifTrue:
	[
		self imgQusNo2 center: ((self inputSensor cursorPoint) - (30@30)). 
	]
	ifFalse:
	[
			self imgQusNo2 center: ((self qusNoDisplay) dispImage) center. 
			self moveImgQusNo2:0.
	].
! !

!SetsGame methodsFor: 'Question-Generation' stamp: 'Aayush 5/22/2008 14:20'!
swapGridValue
	| count tmpArr |

	tmpArr := Array new:4.

	count:=1.
	[
		tmpArr at:count put: (self gridValueR at:count).

		count := count + 1.
		count <=4
	]whileTrue.
	
	count:=1.
	[
		self gridValueR at:count put: (self gridValueC at:count).

		count := count + 1.
		count <=4
	]whileTrue.

	count:=1.
	[
		self gridValueC at:count put: (tmpArr at:count).

		count := count + 1.
		count <=4
	]whileTrue.
! !

!SetsGame methodsFor: 'miscellaneous' stamp: 'Aayush 6/3/2008 15:33'!
test
	self imgColInfo left: (self left +200 - (self imgColInfo width)).
	self imgColInfo top: (self top + 40).
	self imgRowInfo left: (self left + 75).
	self imgRowInfo top: (self top + 100 - (self imgColInfo height)).
! !

!SetsGame methodsFor: 'miscellaneous' stamp: 'A 5/26/2008 15:48'!
toggleMoveImgQusNo2
	self moveImgQusNo2 = 0 ifTrue:
	[
		self moveImgQusNo2: 1.
	]
	ifFalse:
	[
		self moveImgQusNo2 = 1 ifTrue:
		[
			self moveImgQusNo2: 2.
		]
	]! !

!SequenceableCollection methodsFor: '*ole-removing' stamp: 'lg 11/1/2007 08:38'!
without: element
	^self select: [ :o | o ~= element ].! !

Object subclass: #ActionVerb
	instanceVariableNames: 'verbList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!ActionVerb class methodsFor: 'as yet unclassified' stamp: 'Ram 12/18/2007 12:31'!
newWithVerbs: anOrderedCollection
	| model |
	model:= self basicNew.
	model verbList: anOrderedCollection.
	model initialize.
	^model.
! !

!ActionVerb methodsFor: 'as yet unclassified' stamp: 'Ram 12/18/2007 13:01'!
initialize
	super initialize.
! !

!ActionVerb methodsFor: 'accessing' stamp: 'Ram 12/18/2007 12:15'!
verbList
	"Answer the value of verbList"

	^ verbList! !

!ActionVerb methodsFor: 'accessing' stamp: 'Ram 12/18/2007 12:15'!
verbList: anObject
	"Set the value of verbList"

	verbList _ anObject! !

Object subclass: #AcVerb
	instanceVariableNames: 'verb question image answer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!AcVerb class methodsFor: 'as yet unclassified' stamp: 'Ram 12/20/2007 11:50'!
newVerbWith: aVerb question: aQuestion image: anImage answer: anAnswer
	| model |
	model:= self basicNew.
	model 
		verb: aVerb;
		question: aQuestion;
		image: anImage;
		answer: anAnswer.
	model initialize.
	^model.

		

	! !

!AcVerb class methodsFor: 'as yet unclassified' stamp: 'Ram 12/18/2007 12:44'!
newVerbWith: aVerb question: aQuestion image: anImage
	| model |
	model:= self basicNew.
	model 
		verb: aVerb;
		question: aQuestion;
		image: anImage.
	model initialize.
	^model.

		

	! !

!AcVerb methodsFor: 'accessing' stamp: 'Ram 12/20/2007 11:46'!
answer
	"Answer the value of answer"

	^ answer! !

!AcVerb methodsFor: 'accessing' stamp: 'Ram 12/20/2007 11:46'!
answer: anObject
	"Set the value of answer"

	answer _ anObject! !

!AcVerb methodsFor: 'accessing' stamp: 'Ram 12/18/2007 12:34'!
image
	"Answer the value of image"

	^ image! !

!AcVerb methodsFor: 'accessing' stamp: 'Ram 12/18/2007 12:34'!
image: anObject
	"Set the value of image"

	image _ anObject! !

!AcVerb methodsFor: 'accessing' stamp: 'Ram 12/18/2007 12:34'!
question
	"Answer the value of question"

	^ question! !

!AcVerb methodsFor: 'accessing' stamp: 'Ram 12/18/2007 12:34'!
question: anObject
	"Set the value of question"

	question _ anObject! !

!AcVerb methodsFor: 'accessing' stamp: 'Ram 12/18/2007 12:34'!
verb
	"Answer the value of verb"

	^ verb! !

!AcVerb methodsFor: 'accessing' stamp: 'Ram 12/18/2007 12:34'!
verb: anObject
	"Set the value of verb"

	verb _ anObject! !

Object subclass: #AnimalKingdom
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

Object subclass: #ColorPattern
	instanceVariableNames: 'blueCount yellowCount orangeCount greenCount colorList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!ColorPattern methodsFor: 'accessing' stamp: 'Ram 12/13/2007 11:00'!
blueCount
	"Answer the value of blueCount"

	^ blueCount! !

!ColorPattern methodsFor: 'accessing' stamp: 'Ram 12/13/2007 11:00'!
blueCount: anObject
	"Set the value of blueCount"

	blueCount _ anObject! !

!ColorPattern methodsFor: 'accessing' stamp: 'Ram 12/21/2007 10:21'!
clearPattern: object

	
| myPlayer |
	object allMorphsDo:[:sub | 
		(sub isKindOf: ImageMorph)ifTrue:[
		myPlayer := sub player.

		]
	]! !

!ColorPattern methodsFor: 'accessing' stamp: 'Ram 12/13/2007 11:00'!
colorList
	"Answer the value of colorList"

	^ colorList! !

!ColorPattern methodsFor: 'accessing' stamp: 'Ram 12/13/2007 11:00'!
colorList: anObject
	"Set the value of colorList"

	colorList _ anObject! !

!ColorPattern methodsFor: 'accessing' stamp: 'Ram 12/13/2007 11:00'!
greenCount
	"Answer the value of greenCount"

	^ greenCount! !

!ColorPattern methodsFor: 'accessing' stamp: 'Ram 12/13/2007 11:00'!
greenCount: anObject
	"Set the value of greenCount"

	greenCount _ anObject! !

!ColorPattern methodsFor: 'accessing' stamp: 'Ram 12/13/2007 11:11'!
initialize
	super initialize.
	self orangeCount:0.
	self blueCount:0.
	self yellowCount:0.
	self greenCount: 0.
	self colorList: OrderedCollection new.
! !

!ColorPattern methodsFor: 'accessing' stamp: 'Ram 12/13/2007 11:03'!
iteratePattern: object
	
| myPlayer myColor |
	object allMorphsDo:[:sub | 
		(sub isKindOf: ImageMorph)ifTrue:[
		myPlayer := sub player.
		myColor := myPlayer getColor1.
		(myColor = (Color r: 1.0 g: 1.0 b: 0.194)) ifTrue:[
			colorList add: 'Yellow'.
			yellowCount:= yellowCount +1.
			].
		(myColor = (Color r: 0.387 g: 0.613 b: 0.0)) ifTrue:[
			colorList add: 'Green'.
			greenCount:=greenCount +1.
			].
		(myColor = (Color r: 1.0 g: 0.484 b: 0.0)) ifTrue:[
			colorList add: 'Orange'.
			orangeCount:= orangeCount + 1.
			].
		(myColor = (Color r: 0.0 g: 0.194 b: 1.0)) ifTrue:[
			colorList add: 'Blue'.
			blueCount:= blueCount + 1.
			].
		]
	]! !

!ColorPattern methodsFor: 'accessing' stamp: 'Ram 12/13/2007 11:00'!
orangeCount
	"Answer the value of orangeCount"

	^ orangeCount! !

!ColorPattern methodsFor: 'accessing' stamp: 'Ram 12/13/2007 11:00'!
orangeCount: anObject
	"Set the value of orangeCount"

	orangeCount _ anObject! !

!ColorPattern methodsFor: 'accessing' stamp: 'Ram 12/13/2007 11:00'!
yellowCount
	"Answer the value of yellowCount"

	^ yellowCount! !

!ColorPattern methodsFor: 'accessing' stamp: 'Ram 12/13/2007 11:00'!
yellowCount: anObject
	"Set the value of yellowCount"

	yellowCount _ anObject! !

Object subclass: #ObjectiveAnswer
	instanceVariableNames: 'answer picture sound correctAnsDescription wrongAnsDescription'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!ObjectiveAnswer methodsFor: 'accessing' stamp: 'Ram 3/30/2008 16:16'!
answer
	"Answer the value of answer"

	^ answer! !

!ObjectiveAnswer methodsFor: 'accessing' stamp: 'Ram 3/30/2008 16:16'!
answer: anObject
	"Set the value of answer"

	answer _ anObject! !

!ObjectiveAnswer methodsFor: 'accessing' stamp: 'Ram 3/30/2008 17:05'!
correctAnsDescription
	"Answer the value of correctAnsDescription"

	^ correctAnsDescription! !

!ObjectiveAnswer methodsFor: 'accessing' stamp: 'Ram 3/30/2008 17:05'!
correctAnsDescription: anObject
	"Set the value of correctAnsDescription"

	correctAnsDescription _ anObject! !

!ObjectiveAnswer methodsFor: 'accessing' stamp: 'Ram 3/30/2008 16:16'!
picture
	"Answer the value of picture"

	^ picture! !

!ObjectiveAnswer methodsFor: 'accessing' stamp: 'Ram 3/30/2008 16:16'!
picture: anObject
	"Set the value of picture"

	picture _ anObject! !

!ObjectiveAnswer methodsFor: 'accessing' stamp: 'Ram 3/30/2008 16:16'!
sound
	"Answer the value of sound"

	^ sound! !

!ObjectiveAnswer methodsFor: 'accessing' stamp: 'Ram 3/30/2008 16:16'!
sound: anObject
	"Set the value of sound"

	sound _ anObject! !

!ObjectiveAnswer methodsFor: 'accessing' stamp: 'Ram 3/30/2008 17:05'!
wrongAnsDescription
	"Answer the value of wrongAnsDescription"

	^ wrongAnsDescription! !

!ObjectiveAnswer methodsFor: 'accessing' stamp: 'Ram 3/30/2008 17:05'!
wrongAnsDescription: anObject
	"Set the value of wrongAnsDescription"

	wrongAnsDescription _ anObject! !

Object subclass: #ObjectiveQuestion
	instanceVariableNames: 'optionList questionSound correctAns question picture'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!ObjectiveQuestion methodsFor: 'option' stamp: 'Ram 3/30/2008 12:18'!
addOption: aString
	optionList add: aString
! !

!ObjectiveQuestion methodsFor: 'accessing' stamp: 'Ram 3/30/2008 12:16'!
correctAns
	"Answer the value of correctAns"

	^ correctAns! !

!ObjectiveQuestion methodsFor: 'accessing' stamp: 'Ram 3/30/2008 12:16'!
correctAns: anObject
	"Set the value of correctAns"

	correctAns _ anObject! !

!ObjectiveQuestion methodsFor: 'option' stamp: 'Ram 3/30/2008 12:19'!
noOfOption
	^optionList size.
! !

!ObjectiveQuestion methodsFor: 'accessing' stamp: 'Ram 3/30/2008 12:16'!
optionList
	"Answer the value of optionList"

	^ optionList! !

!ObjectiveQuestion methodsFor: 'accessing' stamp: 'Ram 3/30/2008 12:16'!
optionList: anObject
	"Set the value of optionList"

	optionList _ anObject! !

!ObjectiveQuestion methodsFor: 'option' stamp: 'Ram 3/30/2008 12:26'!
optionSize
	^optionList size.! !

!ObjectiveQuestion methodsFor: 'accessing' stamp: 'Ram 3/30/2008 12:16'!
picture
	"Answer the value of picture"

	^ picture! !

!ObjectiveQuestion methodsFor: 'accessing' stamp: 'Ram 3/30/2008 12:16'!
picture: anObject
	"Set the value of picture"

	picture _ anObject! !

!ObjectiveQuestion methodsFor: 'as yet unclassified' stamp: 'Ram 3/30/2008 12:18'!
prepareQuestion: aString
	optionList:= OrderedCollection new.
	question:= aString! !

!ObjectiveQuestion methodsFor: 'accessing' stamp: 'Ram 3/30/2008 12:16'!
questionSound
	"Answer the value of questionSound"

	^ questionSound! !

!ObjectiveQuestion methodsFor: 'accessing' stamp: 'Ram 3/30/2008 12:16'!
questionSound: anObject
	"Set the value of questionSound"

	questionSound _ anObject! !

!ObjectiveQuestion methodsFor: 'accessing' stamp: 'Ram 3/30/2008 12:16'!
question
	"Answer the value of question"

	^ question! !

!ObjectiveQuestion methodsFor: 'accessing' stamp: 'Ram 3/30/2008 12:16'!
question: anObject
	"Set the value of question"

	question _ anObject! !

Object subclass: #OLE
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

OLE class
	instanceVariableNames: 'halosEnabled authorMode'!

OLE class
	instanceVariableNames: 'halosEnabled authorMode'!

!OLE class methodsFor: 'childproofing' stamp: 'cjs 7/28/2008 17:37'!
authorMode
	Preferences
		disable: #eToyFriendly;
		enable: #warnIfNoSourcesFile;
		enable: #warnIfNoChangesFile;
		enable: #warnIfChangesFileReadOnly;
		disable: #startupInUntrustedDirectory;
		disable: #oleDeploymentMode;
		disable: #noHalos.
	self updateSugarToolbar.! !

!OLE class methodsFor: 'sound effects' stamp: 'lg 9/29/2007 13:02'!
congratulate
	"Not implemented" nil.! !

!OLE class methodsFor: 'childproofing' stamp: 'cjs 7/28/2008 17:38'!
deploy
	self userMode.
	Preferences
		disable: #warnIfNoSourcesFile;
		disable: #warnIfNoChangesFile;
		disable: #warnIfChangesFileReadOnly;
		enable: #startupInUntrustedDirectory;
		enable: #oleDeploymentMode.! !

!OLE class methodsFor: '*ole-project' stamp: 'lg 12/19/2007 14:45'!
ensureImagesAreLoaded
	| dir |
	Images isEmpty ifFalse: [^self].
	dir := Smalltalk imagePath, FileDirectory slash, 'assets', FileDirectory slash, 'currency_notes', FileDirectory slash.
	#(1 2 5 10 25 50 100 500 1000) do: [ :n |
		Images addMorphBack: (SketchMorph fromFile: dir , n asString , '_front.jpg').
		Images addMorphBack: (SketchMorph fromFile: dir , n asString , '_back.jpg').
		Images addMorphBack: (SketchMorph fromFile: dir , 'animal_', n asString , '.jpg')].
! !

!OLE class methodsFor: '*ole-project' stamp: 'lg 12/19/2007 14:19'!
initializeAnimalsOnMoney
	| dir numbers choices answer |
	dir := Smalltalk imagePath, FileDirectory slash, 'assets', FileDirectory slash, 'currency_notes', FileDirectory slash.
	choices := #(1 2 5 10 25 50 100 500 1000 ) shuffled first: 3.
	answer := choices atRandom.
	Hint setGraphic: (self animalGraphic: answer).
	{Choice1. Choice2. Choice3} with: choices do:
		[:choice :note |
			choice
				setFront: (self frontGraphic: note);
				setBack: (self backGraphic: note);
				setCorrect: note == answer.
			choice showFront]! !

!OLE class methodsFor: 'childproofing' stamp: 'lg 12/18/2007 12:19'!
isAuthorMode
	^Preferences eToyFriendly not.
! !

!OLE class methodsFor: 'image' stamp: 'lg 10/14/2007 09:49'!
saveSoon
	[(Delay forSeconds: 10) wait. SmalltalkImage current saveSession] fork.! !

!OLE class methodsFor: 'childproofing' stamp: 'lg 12/20/2007 23:16'!
updateSugarToolbar
	World allMorphsDo: [ :m | (m isKindOf: SugarNavigatorBar) ifTrue: [m removeAllMorphs; addButtons]]! !

!OLE class methodsFor: 'childproofing' stamp: 'lg 12/20/2007 23:16'!
userMode
	Preferences
		enable: #eToyFriendly;
		enable: #noHalos.
	self updateSugarToolbar.! !

!OLE class methodsFor: 'class initialization' stamp: 'lg 12/18/2007 12:26'!
initialize
	Preferences addBooleanPreference: #oleDeploymentMode categories: #('OLE' 'OLPC') default: false balloonHelp: 'Enable behaviour that is appropriate in images running the OLE Nepal E-Paati activities but not in development images, for example automatic removal of projects after use.'
! !

Object subclass: #PictureWordExt
	instanceVariableNames: 'questionList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!PictureWordExt methodsFor: 'as yet unclassified' stamp: 'Ram 1/31/2008 15:35'!
addMajorQuesion: questionWithSound minor: aQuestion
	| p1 |
	p1:= Dictionary new.
	p1 at:'major' put: questionWithSound.
	p1 at:'minor' put: aQuestion.
	questionList add: p1.
	
	
! !

!PictureWordExt methodsFor: 'as yet unclassified' stamp: 'Ram 1/31/2008 16:45'!
initialize
	super initialize.
	questionList:= OrderedCollection new.! !

!PictureWordExt methodsFor: 'as yet unclassified' stamp: 'Ram 1/31/2008 16:48'!
majorQuestionAt: aIndex
	
	| question majorQuestion |
	question:= questionList at: aIndex.
	majorQuestion:= question at: 'major'.
	^majorQuestion! !

!PictureWordExt methodsFor: 'as yet unclassified' stamp: 'Ram 1/31/2008 16:48'!
minorQuestionAt: aIndex
	
	| question minorQuestion |
	question:= questionList at: aIndex.
	minorQuestion:= question at: 'minor'.
	^minorQuestion! !

!PictureWordExt methodsFor: 'as yet unclassified' stamp: 'Ram 1/31/2008 15:13'!
prepareQuesion
	questionList:= OrderedCollection new.
	
! !

!PictureWordExt methodsFor: 'accessing' stamp: 'Ram 1/31/2008 15:03'!
questionList
	"Answer the value of questionList"

	^ questionList! !

!PictureWordExt methodsFor: 'accessing' stamp: 'Ram 1/31/2008 15:03'!
questionList: anObject
	"Set the value of questionList"

	questionList _ anObject! !

!Project class methodsFor: '*ole' stamp: 'lg 12/7/2007 10:52'!
fromUnderImage: projectName
	| filename |
	filename :=ProjectLoading findProjectFileNamed: projectName recursivelyInDirectory: Smalltalk imagePath.
	^filename ifNotNil: [Project fromUrl: (FileUrl absoluteFromText: filename) asString].
! !

!Project class methodsFor: '*ole' stamp: 'lg 12/21/2007 13:29'!
iconFor: projectName inDirectory: dirName
	| dir icon |
	dir := FileDirectory on: Smalltalk imagePath, FileDirectory slash, dirName.
	icon := SketchMorph fromFile: (dir fullNameFor: projectName, '.gif').
	icon on: #click send: #openFromDirectory:andProjectName: to: ProjectLoading args: {dirName. projectName}.
	icon on: #mouseEnter send: #mouseOverHighlight to: icon.
	icon on: #mouseLeave send: #mouseOverUnhighlight to: icon.
	^icon
! !

!Project class methodsFor: '*ole' stamp: 'lg 12/21/2007 13:28'!
linksForDirectory: dirName
	| projects morph |
	projects := Project projectsInDirectory: Smalltalk imagePath, FileDirectory slash, dirName.
	projects isEmpty ifTrue: [^nil].
	morph := AlignmentMorph new layoutPolicy: TableLayout new;
		listDirection: #leftToRight;
		wrapCentering: #topLeft;
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap;
		cellInset: 10;
		color: Color transparent.
	projects do: [ :p | morph addMorphBack: (Project iconFor: p inDirectory: dirName)].
	^morph
! !

!Project class methodsFor: '*ole' stamp: 'lg 11/25/2007 11:26'!
namedUnderImage: projectName
	| filename |
	filename :=ProjectLoading findProjectFileNamed: projectName recursivelyInDirectory: Smalltalk imagePath.
	^filename ifNotNil: [Project namedUrl: (FileUrl absoluteFromText: filename)].
! !

!Project class methodsFor: '*ole' stamp: 'lg 12/17/2007 16:01'!
projectsInDirectory: dirName
	| projects parse |
	projects := Set new.
	(FileDirectory on: dirName) fileNames do:
		[ :fn | parse := Project parseProjectFileName: fn.
			(parse at: 3) = 'pr' ifTrue: [projects add: (parse at: 1)]].
	^projects asArray sort.! !

!Project methodsFor: '*ole' stamp: 'lg 10/13/2007 09:05'!
exit
	"Leave the current project and return to the project in which this one was created."

	self isTopProject ifTrue: [^ self beep: 'click' ].
	parentProject enter: false revert: false saveForRevert: false.
! !

!Project methodsFor: '*ole-file in/out' stamp: 'lg 11/24/2007 18:55'!
objectForDataStream: refStrm
	| uu dp |
	"I am about to be written on an object file.  Write a path to me in the other system instead."

	"Use a copy with no parent, previous or next to reduce extra stuff copied"
	refStrm project == self ifTrue: [^ self copy setParent: nil].

	dp _ (uu _ self url) size > 0 ifTrue: [
		(uu asString beginsWith: Smalltalk imagePath asUrl asString) ifTrue: [
			"OLE extension for flexibility: if the project was loaded from a path under the image directory, just remember the project name and then reload it by searching recursively for a project of that name. -luke"
			DiskProxy global: #Project selector: #namedUnderImage: args: {self name}
		] ifFalse: [
			DiskProxy global: #Project selector: #namedUrl: args: {uu}.
		]
	] ifFalse: [
		DiskProxy global: #Project selector: #named: args: {self name}
	].
	refStrm replace: self with: dp.
	^ dp
! !

!Project methodsFor: '*ole-disk i/o' stamp: 'lg 12/7/2007 11:07'!
setupDiskProxyUnderImage
	^DiskProxy new setupForProjectUnderImage: self name! !

Thumbnail subclass: #PicturePuzzleThumbnailMorph
	instanceVariableNames: 'puzzlePictureForm gridSize labels'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

PicturePuzzleThumbnailMorph subclass: #PicturePuzzleFileThumbnailMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!PicturePuzzleThumbnailMorph methodsFor: 'event handling' stamp: 'lg 10/10/2007 14:55'!
handlesMouseDown: event
	^true! !

!PicturePuzzleThumbnailMorph methodsFor: 'initialization' stamp: 'lg 10/13/2007 09:24'!
initialize
	super initialize.
	self maxWidth: 200 minHeight: 150.
	gridSize := 4.! !

!PicturePuzzleThumbnailMorph methodsFor: 'puzzle' stamp: 'lg 10/13/2007 13:09'!
labels: type
	labels := type.! !

!PicturePuzzleThumbnailMorph methodsFor: 'puzzle' stamp: 'lg 10/10/2007 10:38'!
makeThumbnailFromForm: form
	puzzlePictureForm := form.
	^super makeThumbnailFromForm: form.! !

!PicturePuzzleThumbnailMorph methodsFor: 'event handling' stamp: 'lg 10/10/2007 14:55'!
mouseDown: event
	self openPuzzle.! !

!PicturePuzzleThumbnailMorph methodsFor: 'puzzle' stamp: 'lg 10/14/2007 18:34'!
openPuzzle
	| morph |
	World allMorphsDo: [ :m | (m isKindOf: PicturePuzzleMorph) ifTrue: [m delete] ].
	morph := PicturePuzzleMorph new showSketch: (SketchMorph withForm: puzzlePictureForm).
	morph center: World center.
	morph top: 90.
	morph rows: gridSize; columns: gridSize.
	morph labels: (labels caseOf: { [nil] -> [ #() ].
							      [#letters] -> ['ABCDEFGHIJKLMNOPQRSTUVWXYZ' asArray collect: #asString].
							      [#numbers] -> [(1 to: 100) collect: #asString]}).
	morph rescramble.
	morph openInWorld.! !

!DiskProxy methodsFor: '*ole' stamp: 'lg 12/7/2007 10:53'!
enter: returningFlag revert: revertFlag saveForRevert: saveForRevert
	"Look for our project on the server, then try to enter it!!  DiskProxy is acting as a stub for the real thing.  Called from a ProjectViewMorph in the current project.  If have url, use it.  Else look in current Project's server and folder."

	constructorSelector == #namedExample: ifTrue: ["Project namedUrl: xxx"
		^ ((Smalltalk at: globalObjectName) perform: #fromExampleEtoys:
					withArguments: constructorArgs) ].
	constructorSelector == #namedUrl: ifTrue: ["Project namedUrl: xxx"
		^ ((Smalltalk at: globalObjectName) perform: #fromUrl:
					withArguments: constructorArgs) ].
	constructorSelector == #named: ifTrue: [
		CurrentProjectRefactoring currentFromMyServerLoad: constructorArgs first].	"name"
	constructorSelector == #namedUnderImage: ifTrue: [
		^ ((Smalltalk at: globalObjectName) perform: #fromUnderImage: withArguments: constructorArgs)].
! !

!DiskProxy methodsFor: '*ole' stamp: 'lg 12/7/2007 11:01'!
setupForProjectUnderImage: projectName
	globalObjectName := #Project.
	constructorSelector := #namedUnderImage:.
	constructorArgs := { projectName }.
! !

Morph subclass: #GameFeedbackMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!GameFeedbackMorph class methodsFor: 'as yet unclassified' stamp: 'lg 10/12/2007 18:00'!
showState: state
	| class |
	class := state caseOf: { [#happy]   -> [GameHappyMorph].
						 [#neutral] -> [GameNeutralMorph].
						 [#sad]       -> [GameSadMorph] }.
	World selectKind: self do: [ :m | (m isKindOf: class) ifTrue: [m show] ifFalse: [m hide] ].
! !

GameFeedbackMorph subclass: #GameHappyMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

GameFeedbackMorph subclass: #GameNeutralMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

GameFeedbackMorph subclass: #GameSadMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

Morph subclass: #HighlighterMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

Morph subclass: #HighlightMorph
	instanceVariableNames: 'project'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!HighlightMorph methodsFor: 'as yet unclassified' stamp: 'lg 10/12/2007 14:19'!
handlesMouseDown: event
	^true! !

!HighlightMorph methodsFor: 'as yet unclassified' stamp: 'lg 10/12/2007 14:23'!
handlesMouseOver: event
	^true! !

!HighlightMorph methodsFor: 'as yet unclassified' stamp: 'lg 10/13/2007 11:04'!
mouseDown: event
	self color: Color transparent.
	self beep: 'click'.
	project enter! !

!HighlightMorph methodsFor: 'as yet unclassified' stamp: 'lg 10/12/2007 14:25'!
mouseEnter: event
	self color: (Color yellow alpha: 0.3).! !

!HighlightMorph methodsFor: 'as yet unclassified' stamp: 'lg 10/12/2007 14:25'!
mouseLeave: event
	self color: Color transparent.! !

Morph subclass: #MemoryGame
	instanceVariableNames: 'wordPairList imagePairList pictureHolder tiles ansPair gameMode currentOpen previousOpen noOfTilesOpen processTileClickEvent timer magicStar magicStarIndex gameTimePassed magicStarTimePassed gameRunning showingAll showingAllTimePassed pairMatched playTableOf'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!MemoryGame methodsFor: 'accessing - properties' stamp: 'Aayush 4/9/2008 16:11'!
ansPair
	^ansPair
! !

!MemoryGame methodsFor: 'accessing - properties' stamp: 'Aayush 4/9/2008 16:11'!
ansPair: anArray
	ansPair := anArray
! !

!MemoryGame methodsFor: 'Change-Preferences' stamp: 'Aayush 4/14/2008 12:02'!
changeTextDirection:random
	| index x |
	index:=1.
	[
		random = true ifTrue:
		[
			x := 2 random.
			x = 1 ifTrue:
			[
				((self tiles at:index) textBox) heading: -45.
			]
			ifFalse:
			[
				((self tiles at:index) textBox) heading: 45.
			]
		]
		ifFalse:
		[
			((self tiles at:index) textBox) heading: -45.
		].
		index:= index + 1.
		index <=30.
	]whileTrue.! !

!MemoryGame methodsFor: 'Change-Preferences' stamp: 'Aayush 4/14/2008 12:03'!
changeTextSize:size
	| index |
	index:=1.
	[
		((self tiles at:index) textBox) fontName: 'BitstreamVeraSans' size: size.
		index:= index + 1.
		index <=30.
	]whileTrue.! !

!MemoryGame methodsFor: 'Questions-Answers' stamp: 'Aayush 4/10/2008 21:52'!
checkAnswer
	(self ansPair at: (self currentOpen)) = self previousOpen ifTrue:
	[
		^ true.
	]
	ifFalse:
	[
		^ false.
	].! !

!MemoryGame methodsFor: 'accessing - properties' stamp: 'Aayush 4/9/2008 16:09'!
currentOpen
	^currentOpen! !

!MemoryGame methodsFor: 'accessing - properties' stamp: 'Aayush 4/9/2008 16:09'!
currentOpen: aNumber
	currentOpen:= aNumber! !

!MemoryGame methodsFor: 'accessing - properties' stamp: 'Aayush 4/9/2008 16:54'!
gameMode
	^gameMode
! !

!MemoryGame methodsFor: 'accessing - properties' stamp: 'Aayush 4/9/2008 16:55'!
gameMode: aNumber
	gameMode := aNumber.
! !

!MemoryGame methodsFor: 'accessing - properties' stamp: 'Aayush 4/11/2008 12:15'!
gameRunning
	^gameRunning! !

!MemoryGame methodsFor: 'accessing - properties' stamp: 'Aayush 4/11/2008 12:16'!
gameRunning: aBoolean
	gameRunning := aBoolean.! !

!MemoryGame methodsFor: 'accessing - properties' stamp: 'Aayush 4/11/2008 12:09'!
gameTimePassed
	^gameTimePassed! !

!MemoryGame methodsFor: 'accessing - properties' stamp: 'Aayush 4/11/2008 12:09'!
gameTimePassed: aNumber
	gameTimePassed := aNumber! !

!MemoryGame methodsFor: 'Questions-Answers' stamp: 'Aayush 4/11/2008 17:19'!
generateImagePairQuestions
	| list qusCount x tileSelected1 tileSelected2 picFromHolder |

	list := OrderedCollection new.
	list addAll: #(1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30).

	qusCount := 1.
	[
		x :=(list size) random.
		tileSelected1 := list at:x.
	
		(self pictureHolder) cursor: qusCount.
		picFromHolder := (self pictureHolder) valueAtCursor.

		(self tiles at:tileSelected1) showText:false.
		((self tiles at:tileSelected1) textBox) hide.
		((self tiles at:tileSelected1) picture) wearCostume: picFromHolder form.

		list removeAt:x.
		
		Transcript show: '[', tileSelected1 printString, ','.

		x :=(list size) random.
		tileSelected2 := list at:x.

		Transcript show: tileSelected2 printString, '] '.

		(self tiles at:tileSelected2) showText:false.
		((self tiles at:tileSelected2) textBox) hide.
		((self tiles at:tileSelected2) picture) wearCostume: picFromHolder form.

		list removeAt:x.
		(self pictureHolder) cursor: (self pictureHolder) cursor + 1.

		self ansPair at: tileSelected1 put:tileSelected2.
		self ansPair at: tileSelected2 put:tileSelected1.

		qusCount := qusCount + 1.
		qusCount <=15
	]whileTrue.	! !

!MemoryGame methodsFor: 'Questions-Answers' stamp: 'Aayush 4/11/2008 11:04'!
generateImageWordPairQuestions

	| list qusCount x tileSelected1 tileSelected2 picFromHolder |

	list := OrderedCollection new.
	list addAll: #(1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30).


	qusCount := 1.
	[
		x :=(list size) random.
		tileSelected1 := list at:x.
	
		picFromHolder := (self pictureHolder) valueAtCursor.

		(self tiles at:tileSelected1) showText:false.
		((self tiles at:tileSelected1) textBox) hide.
		((self tiles at:tileSelected1) picture) wearCostume: picFromHolder form.

		(self pictureHolder) cursor: (self pictureHolder) cursor + 1.

		list removeAt:x.
		
		Transcript show: '[', tileSelected1 printString, ','.

		x :=(list size) random.
		tileSelected2 := list at:x.

		Transcript show: tileSelected2 printString, '] '.

		(self tiles at:tileSelected2) showText:true.
		((self tiles at:tileSelected1) picture) hide.
		((self tiles at: tileSelected2) textBox) contents: picFromHolder externalName.

		list removeAt:x.
		self ansPair at: tileSelected1 put:tileSelected2.
		self ansPair at: tileSelected2 put:tileSelected1.

		qusCount := qusCount + 1.
		qusCount <=15
	]whileTrue.	! !

!MemoryGame methodsFor: 'Questions-Answers' stamp: 'Aayush 4/11/2008 15:52'!
generateMathQuestions
	| list qusCount x z y tileSelected1 tileSelected2 |

	list := OrderedCollection new.
	list addAll: #(1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30).
"
	z := self playTableOf.
"
	z := 8 random + 1.

	qusCount := 1.
	[
		x :=(list size) random.
		tileSelected1 := list at:x.
	
		y := qusCount + 1.
				
		((self tiles at: tileSelected1) textBox) contents: z printString,'*', y printString.

		list removeAt:	x.
		
		Transcript show: '[', tileSelected1 printString, ','.

		x :=(list size) random.
		tileSelected2 := list at:x.

		Transcript show: tileSelected2 printString, '] '.

		((self tiles at: tileSelected2) textBox) contents: (z*y) printString.

		list removeAt:	x.

		self ansPair at: tileSelected1 put:tileSelected2.
		self ansPair at: tileSelected2 put:tileSelected1.

		qusCount := qusCount + 1.
		qusCount <=15
	]whileTrue.	! !

!MemoryGame methodsFor: 'Questions-Answers' stamp: 'Aayush 4/11/2008 00:43'!
generateWordPairQuestions

	| list qusCount x tileSelected1 tileSelected2 |

	list := OrderedCollection new.
	list addAll: #(1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30).

	qusCount := 1.
	[
		x :=(list size) random.
		tileSelected1 := list at:x.
	
		((self tiles at: tileSelected1) textBox) contents: ((self wordPairList at:qusCount) at:1).

		list removeAt:x.
		
		Transcript show: '[', tileSelected1 printString, ','.

		x :=(list size) random.
		tileSelected2 := list at:x.

		Transcript show: tileSelected2 printString, '] '.

		((self tiles at: tileSelected2) textBox) contents: ((self wordPairList at:qusCount) at:2).

		list removeAt:x.

		self ansPair at: tileSelected1 put:tileSelected2.
		self ansPair at: tileSelected2 put:tileSelected1.

		qusCount := qusCount + 1.
		qusCount <=15
	]whileTrue.	! !

!MemoryGame methodsFor: 'as yet unclassified' stamp: 'Aayush 4/11/2008 11:59'!
getStarIndex
	
	| list tileIndex x |

	list := OrderedCollection new.

	tileIndex := 1.
	[
		(self tiles at: tileIndex) visible = true ifTrue:
		[
			list add: tileIndex.
		].

		tileIndex := tileIndex + 1.
		tileIndex <= 30
	]whileTrue.

	x := (list size)	random.
	
	^ (list at:x).
	
! !

!MemoryGame methodsFor: 'as yet unclassified' stamp: 'Aayush 4/11/2008 13:06'!
hideAll
	| index |
	index := 1.
	[
		(self tiles at:index) textBox hide.
		(self tiles at:index) picture hide.

		index := index + 1.
		index <= 30
	]whileTrue.! !

!MemoryGame methodsFor: 'accessing - properties' stamp: 'Aayush 4/11/2008 11:20'!
imagePairList
	^imagePairList! !

!MemoryGame methodsFor: 'accessing - properties' stamp: 'Aayush 4/11/2008 11:20'!
imagePairList: anArray
	imagePairList := anArray.! !

!MemoryGame methodsFor: 'initialization' stamp: 'Aayush 4/11/2008 17:11'!
initImagePairList
	self imagePairList: (Array new:30).

	self imagePairList at:1 put: 1.
	self imagePairList at:2 put: 2.
	self imagePairList at:3 put: 3.
	self imagePairList at:4 put: 4.
	self imagePairList at:5 put: 5.
	self imagePairList at:6 put: 6.
	self imagePairList at:7 put: 7.
	self imagePairList at:8 put: 8.
	self imagePairList at:9 put: 9.
	self imagePairList at:10 put: 10.
	self imagePairList at:11 put: 11.
	self imagePairList at:12 put: 12.
	self imagePairList at:13 put: 13.
	self imagePairList at:14 put: 14.
	self imagePairList at:15 put: 15.
! !

!MemoryGame methodsFor: 'initialization' stamp: 'Aayush 4/11/2008 15:37'!
initialize
	super initialize.

	self toggleStickiness.

	self gameMode:1.
	self currentOpen:0.
	self previousOpen:0.
	self noOfTilesOpen:0.
	self magicStarIndex:0.
	self gameTimePassed:0.
	self gameRunning: false.
	self magicStarTimePassed:0.
	self processTileClickEvent: true.
	self showingAll: false.
	self showingAllTimePassed:0.
	self pairMatched:0.
	self playTableOf: 2.

	self timer: MyTimer new.
	self timer setTimerHour:1 Minute:0 Second:0.
	self timer countUp: true.
	self timer openInWorld.
	
	self ansPair: (Array new:30).

	self initTilesPosition.

	self magicStar: StarMorph new.
	self magicStar color: (Color r:1 g:0 b:0).
	self magicStar toggleStickiness.

	self addMorph: self magicStar.
	(self magicStar) hide.
! !

!MemoryGame methodsFor: 'initialization' stamp: 'Aayush 4/11/2008 11:31'!
initPictureHolder
	self pictureHolder: PasteUpMorph new.
	self pictureHolder toggleAutoLineLayout.
	self pictureHolder openInWorld.
! !

!MemoryGame methodsFor: 'initialization' stamp: 'Aayush 4/11/2008 11:34'!
initTilesPosition

	| tileIndex tileWidth tileHeight left top row |
	self tiles: (Array new:30).
	tileIndex := 1.
	[
		self tiles at:tileIndex put: MemoryTile new.
		(self tiles at: tileIndex) on: #mouseDown send: #tileClick:v2:v3: to:self withValue:tileIndex.

	tileIndex := tileIndex +1.
	tileIndex<=30] whileTrue.

	tileWidth := (self tiles at:1) width.
	tileHeight := (self tiles at:1) height.

	self bounds: (0@0 extent: (  ((tileWidth*6) + (5*5))  @  ((tileHeight*5) + (4*5))  )  ).

	left := 0.
	top := 0.
	tileIndex := 1.

	row := 1.
	[
		6 timesRepeat:
		[
			self addMorph: (self tiles at: tileIndex).
		

			(self tiles at: tileIndex) left: left.
			(self tiles at: tileIndex) top: top.
			left := left + (self tiles at: tileIndex) width + 5.
			tileIndex := tileIndex + 1.

		].
		top := top + (self tiles at: 1) height + 5.
		left := 0.

		row := row + 1.
		row <=5
	] whileTrue.
	! !

!MemoryGame methodsFor: 'initialization' stamp: 'Aayush 4/11/2008 00:46'!
initWordPairList
	| index |
	self
		wordPairList: (Array new: 15).
	index := 1.
	[(self wordPairList) at:index put: (Array new:2).
	index := index + 1.
	index <= 15] whileTrue.
	(self wordPairList at: 1)
		at: 1
		put: 'Sheep'.
	(self wordPairList at: 1)
		at: 2
		put: 'Wool'.
	(self wordPairList at: 2)
		at: 1
		put: 'Cow'.
	(self wordPairList at: 2)
		at: 2
		put: 'Milk'.
	(self wordPairList at: 3)
		at: 1
		put: 'Wheat'.
	(self wordPairList at: 3)
		at: 2
		put: 'Flour'.
	(self wordPairList at: 4)
		at: 1
		put: 'Hen'.
	(self wordPairList at: 4)
		at: 2
		put: 'Egg'.
	(self wordPairList at: 5)
		at: 1
		put: 'Bee'.
	(self wordPairList at: 5)
		at: 2
		put: 'Honey'.
	(self wordPairList at: 6)
		at: 1
		put: 'Lamp'.
	(self wordPairList at: 6)
		at: 2
		put: 'Light'.
	(self wordPairList at: 7)
		at: 1
		put: 'Cloud'.
	(self wordPairList at: 7)
		at: 2
		put: 'Rain'.
	(self wordPairList at: 8)
		at: 1
		put: 'Tap'.
	(self wordPairList at: 8)
		at: 2
		put: 'Watar'.
	(self wordPairList at: 9)
		at: 1
		put: 'Tree'.
	(self wordPairList at: 9)
		at: 2
		put: 'Fruit'.
	(self wordPairList at: 10)
		at: 1
		put: 'Wood'.
	(self wordPairList at: 10)
		at: 2
		put: 'Chair'.
	(self wordPairList at: 11)
		at: 1
		put: 'Cloth'.
	(self wordPairList at: 11)
		at: 2
		put: 'Shirt'.
	(self wordPairList at: 12)
		at: 1
		put: 'Brick'.
	(self wordPairList at: 12)
		at: 2
		put: 'House'.
	(self wordPairList at: 13)
		at: 1
		put: 'Sugar'.
	(self wordPairList at: 13)
		at: 2
		put: 'Sweet'.
	(self wordPairList at: 14)
		at: 1
		put: 'Glass'.
	(self wordPairList at: 14)
		at: 2
		put: 'Bottle'.
	(self wordPairList at: 15)
		at: 1
		put: 'Leather'.
	(self wordPairList at: 15)
		at: 2
		put: 'Shoes'! !

!MemoryGame methodsFor: 'accessing - properties' stamp: 'Aayush 4/11/2008 12:08'!
magicStarIndex
	^magicStarIndex.! !

!MemoryGame methodsFor: 'accessing - properties' stamp: 'Aayush 4/11/2008 12:09'!
magicStarIndex: aNumber
	magicStarIndex := aNumber.! !

!MemoryGame methodsFor: 'accessing - properties' stamp: 'Aayush 4/11/2008 12:10'!
magicStarTimePassed
	^magicStarTimePassed! !

!MemoryGame methodsFor: 'accessing - properties' stamp: 'Aayush 4/11/2008 12:10'!
magicStarTimePassed: aNumber
	magicStarTimePassed := aNumber! !

!MemoryGame methodsFor: 'accessing - properties' stamp: 'Aayush 4/11/2008 11:52'!
magicStar
	^magicStar! !

!MemoryGame methodsFor: 'accessing - properties' stamp: 'Aayush 4/11/2008 11:52'!
magicStar: aStarMorph
	magicStar := aStarMorph! !

!MemoryGame methodsFor: 'Questions-Answers' stamp: 'Aayush 4/11/2008 11:06'!
makeNewQuestions
	
	| x |
	self gameMode = 1 ifTrue:
	[
		self generateMathQuestions.
	]
	ifFalse:
	[
		self gameMode = 2 ifTrue:
		[
			self generateImageWordPairQuestions.
		]
		ifFalse:
		[
			self gameMode = 3 ifTrue:
			[
				self generateImagePairQuestions.
			]
			ifFalse:
			[
				self gameMode = 4 ifTrue:
				[
					self generateWordPairQuestions.
				]
				ifFalse:
				[
	
				]
			]
		]
	].

	x :=1.
	[
		((self tiles at:x) textBox) center: ((self tiles at:x) center).
		((self tiles at:x) picture) center: ((self tiles at:x) center).
		x := x + 1.
		x <= 30
	]whileTrue.
	! !

!MemoryGame methodsFor: 'accessing - properties' stamp: 'Aayush 4/10/2008 20:12'!
noOfTilesOpen
	^noOfTilesOpen! !

!MemoryGame methodsFor: 'accessing - properties' stamp: 'Aayush 4/10/2008 20:12'!
noOfTilesOpen: aNumber
	noOfTilesOpen := aNumber! !

!MemoryGame methodsFor: 'accessing - properties' stamp: 'Aayush 4/11/2008 13:10'!
pairMatched
	^pairMatched! !

!MemoryGame methodsFor: 'accessing - properties' stamp: 'Aayush 4/11/2008 13:10'!
pairMatched: aNumber
	pairMatched := aNumber.! !

!MemoryGame methodsFor: 'accessing - properties' stamp: ''!
pictureHolder
	^ pictureHolder! !

!MemoryGame methodsFor: 'accessing - properties' stamp: ''!
pictureHolder: aPasteUpMorph 
	pictureHolder := aPasteUpMorph! !

!MemoryGame methodsFor: 'as yet unclassified' stamp: 'Aayush 4/11/2008 11:58'!
placeStarAt: tileIndex
	
	| left top row col qus rem |

	row := 1.
	col := tileIndex.

	tileIndex > 6 ifTrue:
	[
		qus := tileIndex // 6.
		rem := tileIndex \\ 6.

		col := rem.
		row := qus.

		col ~= 0 ifTrue:
		[
			row := qus + 1.						
		]
		ifFalse:
		[
			col := 6.
		]
	].

	left :=  ( (col-1) * ((self tiles at:1) width) + ((col-1)*5) ) + self left.
	top :=  ( (row-1) * ((self tiles at:1) height) + ((row-1)*5) ) + self top.

	(self magicStar) left: left.
	(self magicStar) top: top.

	(self magicStar) comeToFront.
	(self magicStar) show.
! !

!MemoryGame methodsFor: 'accessing - properties' stamp: 'Aayush 4/11/2008 15:30'!
playTableOf
	^playTableOf! !

!MemoryGame methodsFor: 'accessing - properties' stamp: 'Aayush 4/11/2008 15:31'!
playTableOf: aNumber
	playTableOf := aNumber.! !

!MemoryGame methodsFor: 'accessing - properties' stamp: 'Aayush 4/9/2008 16:10'!
previousOpen
	^previousOpen! !

!MemoryGame methodsFor: 'accessing - properties' stamp: 'Aayush 4/9/2008 16:09'!
previousOpen: aNumber
	previousOpen:= aNumber! !

!MemoryGame methodsFor: 'accessing - properties' stamp: 'Aayush 4/10/2008 22:50'!
processTileClickEvent
	^processTileClickEvent! !

!MemoryGame methodsFor: 'accessing - properties' stamp: 'Aayush 4/10/2008 22:50'!
processTileClickEvent: aBoolean
	processTileClickEvent := aBoolean! !

!MemoryGame methodsFor: 'as yet unclassified' stamp: 'Aayush 4/11/2008 16:14'!
reset
	| index |
	
	self pairMatched:0.
	self currentOpen:0.
	self previousOpen:0.
	self noOfTilesOpen:0.
	self showingAll: false.
	self magicStarIndex:0.
	self magicStar hide.
	self gameTimePassed:0.
	self gameRunning: false.
	self magicStarTimePassed:0.
	self showingAllTimePassed:0.
	self processTileClickEvent: true.
	self timer reset.

	index := 1.
	[
		(self tiles at:index) show.
		(self tiles at:index) textBox hide.
		(self tiles at:index) picture hide.

		index := index + 1.
		index <= 30
	]whileTrue.! !

!MemoryGame methodsFor: 'as yet unclassified' stamp: 'Aayush 4/11/2008 13:07'!
showAll
	| index |
	index := 1.
	[
		(self tiles at:index) visible = true ifTrue:
		[
			(self tiles at:index) showText = true ifTrue:
			[
				(self tiles at:index) textBox show.
			]
			ifFalse:
			[
				(self tiles at:index) picture show.
			]
		].

		index := index + 1.
		index <= 30
	]whileTrue.! !

!MemoryGame methodsFor: 'accessing - properties' stamp: 'Aayush 4/11/2008 12:57'!
showingAllTimePassed
	^showingAllTimePassed
! !

!MemoryGame methodsFor: 'accessing - properties' stamp: 'Aayush 4/11/2008 12:57'!
showingAllTimePassed: aNumber
	showingAllTimePassed := aNumber
! !

!MemoryGame methodsFor: 'accessing - properties' stamp: 'Aayush 4/11/2008 12:56'!
showingAll
	^showingAll! !

!MemoryGame methodsFor: 'accessing - properties' stamp: 'Aayush 4/11/2008 12:56'!
showingAll: aBoolean
	showingAll := aBoolean.! !

!MemoryGame methodsFor: 'as yet unclassified' stamp: 'Aayush 4/11/2008 14:45'!
startNewGame
	self reset.
	self makeNewQuestions.
	self gameRunning: true.
	self timer start.
	self startStepping.! !

!MemoryGame methodsFor: 'as yet unclassified' stamp: 'Aayush 4/11/2008 12:11'!
stepTime
	^1000! !

!MemoryGame methodsFor: 'as yet unclassified' stamp: 'Aayush 4/14/2008 17:05'!
step
	self gameRunning = false ifTrue:
	[
		self stopStepping.
	]
	ifFalse:
	[
		self gameTimePassed: self gameTimePassed + 1.

		self showingAll = true ifTrue:
		[
			self showingAllTimePassed:  self showingAllTimePassed + 1.

			self showingAllTimePassed = 7 ifTrue:
			[
				self showingAllTimePassed:  0.
				self showingAll: false.
				self processTileClickEvent:true.
				self hideAll.
			]
		].

		(self magicStar)  visible = true ifTrue:
		[
			self magicStarTimePassed: self magicStarTimePassed +1.		

			self magicStarTimePassed = 5 ifTrue:
			[
				(self magicStar) hide.
				self magicStarTimePassed:0.
				self magicStarIndex:0.
			]
		].

		self gameTimePassed = 10 ifTrue:
		[
			self gameTimePassed:0.
			self magicStarIndex:   (self getStarIndex).
			self placeStarAt: (self magicStarIndex).
		]
	]
! !

!MemoryGame methodsFor: 'events-processing' stamp: 'Aayush 4/11/2008 12:28'!
tileClick:tileIndex v2:x v3:y
	self gameRunning = true ifTrue:
	[
		self processTileClickEvent = true ifTrue:
		[
			self processTileClickEvent: false.
			self currentOpen = tileIndex ifTrue:
			[
				self noOfTilesOpen: 0.
				self previousOpen: 0.
				self currentOpen: 0.
				self processTileClickEvent: true.
			]
			ifFalse:
			[
				self noOfTilesOpen: self noOfTilesOpen + 1.
				self previousOpen: self currentOpen.
				self currentOpen: tileIndex.
			].
			(self tiles at:tileIndex) startStepping.
		]
	]

! !

!MemoryGame methodsFor: 'accessing - properties' stamp: 'Aayush 4/9/2008 15:12'!
tiles
	^tiles.! !

!MemoryGame methodsFor: 'accessing - properties' stamp: 'Aayush 4/9/2008 15:12'!
tiles: anArray
	tiles:= anArray! !

!MemoryGame methodsFor: 'accessing - properties' stamp: 'Aayush 4/11/2008 11:42'!
timer
	^timer! !

!MemoryGame methodsFor: 'accessing - properties' stamp: 'Aayush 4/11/2008 11:43'!
timer: timerMorph
	timer :=  timerMorph.! !

!MemoryGame methodsFor: 'accessing - properties' stamp: 'Aayush 4/9/2008 16:17'!
wordPairList
	^ wordPairList! !

!MemoryGame methodsFor: 'accessing - properties' stamp: 'Aayush 4/9/2008 16:17'!
wordPairList: anArray 
	wordPairList := anArray! !

!Morph class methodsFor: '*ole-scripting' stamp: 'lg 10/30/2007 17:27'!
additionsToViewerCategoryAsObject
	"Answer viewer additions for the 'as object' category.  Just priming the pump at this point."

	^#(
		#'as object' 
		(
			(slot size 'My physical size' Number readOnly Player getObjectSize unused unused)
			(slot name  	'The name by which I am known' String readWrite Player 	getName Player setName:)
			(slot hash 'My hash value' Number readOnly Player getHash unused unused)
			(command explore 'Open up an Explorer on this object')
			(command halt: 'Put up a pre-debug notifier' String)
			(slot printString 'A string rendition of myself' String readOnly  Player getPrintString unused unused)
			(command inform: 'Put up message box for the user' String)
			(command printInTranscript 'Prints a description of the object to the Transcript')
			(command printDirectlyToDisplay 'Prints a description of the object directly to the screen')
			(command waitForSeconds: 'Wait for a period of seconds (Squeak will not execute other scripts during this time)' Number)
			(slot className 'The name of the class of the object' String readOnly player getClassName unused unused)

		))
! !

!Morph class methodsFor: '*ole-scripting' stamp: 'lg 11/1/2007 10:36'!
additionsToViewerCategoryGameInstrument
	(World allMorphs select: [ :m | m isKindOf: AddingGameMorph]) ifEmpty: [^ #() ].
	^#( #'game instrument'
			( (slot gameInstrumentType 'The type of game instrument.' GameInstrumentType readWrite Player getGameInstrumentType Player setGameInstrumentType:)
"			  (slot gameValue 'The numeric value' Number readWrite Player getGameValue Player setGameValue:)" )
		)! !

!Morph class methodsFor: '*ole-scripting' stamp: 'lg 10/29/2007 14:46'!
supportsGameValue
	^false! !

!Morph methodsFor: '*ole-game' stamp: 'lg 10/30/2007 12:44'!
addGameItemsTo: aMenu hand: aHandMorph
"	aMenu add: 'OLE game...' translated subMenu:  (self buildGameMenu: aHandMorph)"! !

!Morph methodsFor: '*ole-menu' stamp: 'lg 10/29/2007 17:49'!
beGameChoiceString
	^ (self gameInstrumentType = #choice) yesNoString , 'be game choice'.! !

!Morph methodsFor: '*ole-menu' stamp: 'lg 10/29/2007 17:49'!
beGameInputString
	^ (self gameInstrumentType = #input) yesNoString , 'be game input'.! !

!Morph methodsFor: '*ole-menu' stamp: 'lg 10/29/2007 17:49'!
buildGameMenu: aHand
	| aMenu |
	aMenu := MenuMorph new defaultTarget: self.
	aMenu addStayUpItem.
	self hasGameValue ifTrue:
		[aMenu addUpdating: #beGameInputString target: self selector: #toggleGameInstrumentType: argumentList: { #gameInput }.
		 aMenu addUpdating: #beGameChoiceString target: self selector: #toggleGameInstrumentType: argumentList: { #gameChoice } ].
	^ aMenu! !

!Morph methodsFor: '*ole' stamp: 'lg 9/25/2007 10:20'!
exchangeWith: morph 
	morph position: self position; extent: self extent.
	owner replaceSubmorph: self by: morph.! !

!Morph methodsFor: '*ole-bugfix' stamp: 'lg 10/2/2007 15:44'!
fixYourLayout
	| realExtent |
	realExtent := self extent.
	self extent: 10@10.
	self extent: realExtent.! !

!Morph methodsFor: '*ole-game-element' stamp: 'lg 10/29/2007 17:37'!
gameChoices
	^self gameInstrumentsOfType: #choice.! !

!Morph methodsFor: '*ole-game-element' stamp: 'lg 10/29/2007 17:37'!
gameInputs
	^self gameInstrumentsOfType: #input.! !

!Morph methodsFor: '*ole-game-element' stamp: 'lg 11/26/2007 11:58'!
gameInstrumentsOfType: type
	| morphs |
	morphs := self allMorphs select: [ :m | (m valueOfProperty: #gameInstrumentType) = type ].
	^morphs asArray sort: [ :a :b | (a x + a y) < (b x + b y) ].! !

!Morph methodsFor: '*ole-game-element' stamp: 'lg 10/29/2007 17:38'!
gameInstrumentType
	^(self valueOfProperty: #gameInstrumentType) ifNil: [#none].! !

!Morph methodsFor: '*ole-game-element' stamp: 'lg 10/29/2007 17:38'!
gameInstrumentType: type
	self setProperty: #gameInstrumentType toValue: type.! !

!Morph methodsFor: '*ole' stamp: 'lg 10/10/2007 10:33'!
grab
	self center: World activeHand center.
	World activeHand grabMorph: self.! !

!Morph methodsFor: '*ole-game-element' stamp: 'lg 10/29/2007 11:36'!
hasGameValue
	^false.! !

!Morph methodsFor: '*ole' stamp: 'lg 10/13/2007 10:06'!
highlightOnMouseOver
	| morph |
	morph := SimpleHighlightMorph new beSticky; extent: self extent; position: self position.
	self addMorph:morph.! !

!Morph methodsFor: '*ole-event handling' stamp: 'lg 12/17/2007 18:40'!
invocation: spec event: ignored1 morph: ignored2
	(spec at: 1) perform: (spec at: 2) withArguments: (spec at: 3).! !

!Morph methodsFor: '*ole-game' stamp: 'lg 10/2/2007 15:10'!
isGameChoice
	^false! !

!Morph methodsFor: '*ole-game-element' stamp: 'lg 10/29/2007 17:38'!
isGameInput
	^self gameInstrumentType = #gameInput.! !

!Morph methodsFor: '*ole' stamp: 'lg 10/8/2007 17:10'!
isGameLevel
	^false! !

!Morph methodsFor: '*ole-game' stamp: 'lg 10/3/2007 12:46'!
isGameMistakes
	^false! !

!Morph methodsFor: '*ole-game' stamp: 'lg 10/2/2007 16:51'!
isGameScore
	^false! !

!Morph methodsFor: '*ole' stamp: 'lg 10/13/2007 14:03'!
isGameTotal
	^false! !

!Morph methodsFor: '*ole-event handling' stamp: 'lg 12/17/2007 18:37'!
morph: ignored1 event: ignored2 invocation: spec.
	(spec at: 1) perform: (spec at: 2) withArguments: (spec at: 3).! !

!Morph methodsFor: '*ole-highlight' stamp: 'lg 12/20/2007 22:27'!
mouseOverHighlight
	| highlight |
	highlight := Morph new color: (Color yellow alpha: 0.25).
	highlight lock; extent: self extent; position: self position.
	self addMorph: highlight.
! !

!Morph methodsFor: '*ole-highlight' stamp: 'lg 12/20/2007 22:29'!
mouseOverUnhighlight
	self removeAllMorphs.! !

!Morph methodsFor: '*ole-event handling' stamp: 'lg 12/17/2007 18:43'!
on: event send: selector to: object args: args
	self on: event send: #invocation:event:morph: to: self withValue: {object. selector. args}
! !

!Morph methodsFor: '*ole' stamp: 'lg 9/24/2007 17:00'!
ripOff
	| m |
	m := RipoffPatchMorph new initialize setTarget: self.
	owner addMorph: m after: self.
	owner removeMorph: self.
	self position: World activeHand position.
	World activeHand grabMorph: self.
! !

!Morph methodsFor: '*ole' stamp: 'lg 9/29/2007 13:03'!
ripoff
   | morph patch |
	morph := RippedOffMorph new setTarget: self.
	patch := RipoffPatchMorph new setTarget: morph.
	morph setPatch: patch.
	self exchangeWith: patch.
	morph center: World activeHand center.
	World activeHand grabMorph: morph.
! !

!Morph methodsFor: '*ole' stamp: 'lg 10/12/2007 17:46'!
selectKind: class do: aBlock 
	self allMorphsDo: [ :morph | (morph isKindOf: class) ifTrue: [aBlock value: morph]].! !

!Morph methodsFor: '*ole' stamp: 'lg 10/3/2007 12:45'!
selectMorphs: test do: aBlock 
	self allMorphsDo: [ :morph | (test value: morph) ifTrue: [aBlock value: morph]].! !

!Morph methodsFor: '*OLE' stamp: 'ss 10/5/2007 13:41'!
showAnimal
           World addMorph: self.
           self position: 200@200! !

!Morph methodsFor: '*ole' stamp: 'lg 10/11/2007 13:06'!
spreadMorphs
	| morph stream blockWidth blockHeight spareWidth spareHeight objectWidth objectHeight columns rows |
	self submorphs isEmpty ifTrue: [^self].
	columns := self submorphs size sqrt roundedUp.
	rows := (self submorphs size / columns) roundedUp.
	blockWidth := self width / columns.
	blockHeight := self height / rows.
	objectWidth := self submorphs first width.
	objectHeight := self submorphs first height.
	spareWidth := blockWidth - objectWidth max: 0.
	spareHeight := blockHeight - objectHeight max: 0.
	stream := self submorphs readStream.
	(0 to: rows-1) do: [:row | (0 to: columns-1) do: [:col |
		morph := stream next.
		morph ifNotNil: [morph position: self position + ((col * blockWidth + (0 to: spareWidth) atRandom) @ (row * blockHeight + (0 to: spareHeight) atRandom))]
	]]! !

!Morph methodsFor: '*ole-game-element' stamp: 'lg 10/29/2007 14:52'!
supportsGameValue
	^self class supportsGameValue.! !

!Morph methodsFor: '*ole' stamp: 'lg 11/26/2007 16:36'!
takeMorphs: morphs mirroringSubmorphsOf: x
	| sourcePositions relativePositions destinationPositions morph source dest |
	sourcePositions := morphs collect: #position.
	relativePositions := x submorphs collect: [ :m | m position - m owner position ].
	destinationPositions := relativePositions collect: [ :point | point + self position ].
	morphs do: [ :m | World addMorph: m ].
"	self break."
	(0 to: 1 by: 0.01) do: [ :amount | (1 to: morphs size) do: [ :ix |
		morph := morphs at: ix.
		source := sourcePositions at: ix.
		dest := destinationPositions at: ix.
		morph position: (source interpolateTo: dest at: amount).
		World displayWorldSafely.
	]].
	morphs do: [ :m | self addMorph: m ].
! !

!Morph methodsFor: '*ole-game-element' stamp: 'lg 10/29/2007 17:37'!
toggleGameInstrumentType: type
	| newType |
	newType := self gameInstrumentType = type ifTrue: [nil] ifFalse: [type].
	self gameInstrumentType: newType.! !

!Morph methodsFor: '*ole' stamp: 'ss 12/14/2007 14:27'!
waitForSeconds: n 
	World displayWorldSafely.
	(Delay forSeconds: n) wait.! !

!Morph methodsFor: '*ole-override' stamp: 'lg 12/18/2007 12:42'!
wantsHaloFromClick

	^ self valueOfProperty: #wantsHaloFromClick ifAbsent: [^Preferences noHalos not].! !

Morph subclass: #MyTimer
	instanceVariableNames: 'ledHour ledMinute ledSecond counting countUp aHour aMinute aSecond'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!MyTimer methodsFor: 'accessingSelf' stamp: ''!
aHour
	^ aHour! !

!MyTimer methodsFor: 'accessingSelf' stamp: ''!
aHour: aNumber 
	(aNumber >= 0
			and: [aNumber < 100])
		ifTrue: [aHour := aNumber]
		ifFalse: [aHour := 0]! !

!MyTimer methodsFor: 'accessingSelf' stamp: ''!
aMinute
	^ aMinute! !

!MyTimer methodsFor: 'accessingSelf' stamp: ''!
aMinute: aNumber 
	(aNumber >= 0
			and: [aNumber < 60])
		ifTrue: [aMinute := aNumber]
		ifFalse: [aMinute := 0]! !

!MyTimer methodsFor: 'accessingSelf' stamp: ''!
aSecond
	^ aSecond! !

!MyTimer methodsFor: 'accessingSelf' stamp: ''!
aSecond: aNumber 
	(aNumber >= 0
			and: [aNumber < 60])
		ifTrue: [aSecond := aNumber]
		ifFalse: [aSecond := 0]! !

!MyTimer methodsFor: 'accessingSelf' stamp: ''!
counting
	^ counting! !

!MyTimer methodsFor: 'accessingSelf' stamp: ''!
counting: aBoolean 
	counting := aBoolean! !

!MyTimer methodsFor: 'accessingSelf' stamp: ''!
countUp
	^ countUp! !

!MyTimer methodsFor: 'accessingSelf' stamp: ''!
countUp: aBoolean 
	countUp := aBoolean.
	aBoolean = true
		ifTrue: [self
				displayTimeHour: 0
				Minute: 0
				Second: 0]
		ifFalse: [self
				displayTimeHour: self aHour
				Minute: self aMinute
				Second: self aSecond]! !

!MyTimer methodsFor: 'timer' stamp: ''!
displayTimeHour: h Minute: m Second: s 
	self ledHour value: h.
	self ledMinute value: m.
	self ledSecond value: s! !

!MyTimer methodsFor: 'initialization' stamp: 'aayush 3/19/2008 14:17'!
initializeSelf
	self width: 154.
	self
		color: (Color
				r: 0
				g: 1
				b: 0).
	self ledHour: LedMorph new.
	self addMorph: self ledHour.
	self ledHour left: 0.
	self ledMinute: LedMorph new.
	self addMorph: self ledMinute.
	self ledMinute left: 52.
	self ledSecond: LedMorph new.
	self addMorph: self ledSecond.
	self ledSecond left: 104.
	self
		setTimerHour: 0
		Minute: 1
		Second: 5.
	self countUp: false.
	self reset.

	"self assuredPlayer."
	self player class compileSilently: 'timeUp' classified: 'scripts'.
	"self player class assuredMethodInterfaceFor: #timeUp"
! !

!MyTimer methodsFor: 'initialization' stamp: ''!
initialize
	super initialize.
	self initializeSelf! !

!MyTimer methodsFor: 'accessingSelf' stamp: ''!
ledHour
	^ ledHour! !

!MyTimer methodsFor: 'accessingSelf' stamp: ''!
ledHour: aLedMorph 
	ledHour := aLedMorph! !

!MyTimer methodsFor: 'accessingSelf' stamp: ''!
ledMinute
	^ ledMinute! !

!MyTimer methodsFor: 'accessingSelf' stamp: ''!
ledMinute: aLedMorph 
	ledMinute := aLedMorph! !

!MyTimer methodsFor: 'accessingSelf' stamp: ''!
ledSecond
	^ ledSecond! !

!MyTimer methodsFor: 'accessingSelf' stamp: ''!
ledSecond: aLedMorph 
	ledSecond := aLedMorph! !

!MyTimer methodsFor: 'timer' stamp: ''!
pause
	self counting: false! !

!MyTimer methodsFor: 'timer' stamp: ''!
reset
	self countUp: self countUp.
	self counting: false! !

!MyTimer methodsFor: 'timer' stamp: ''!
setTimerHour: h Minute: m Second: s 
	self aHour: h.
	self aMinute: m.
	self aSecond: s.
	self reset! !

!MyTimer methodsFor: 'timer' stamp: ''!
start
	self counting: true! !

!MyTimer methodsFor: 'timer' stamp: ''!
stepTime
	^ 1000! !

!MyTimer methodsFor: 'as yet unclassified' stamp: ''!
step
	self counting = true
		ifTrue: [self updateTime]! !

!MyTimer methodsFor: 'timer' stamp: ''!
updateTime
	| sec min hr |
	sec := self ledSecond value.
	min := self ledMinute value.
	hr := self ledHour value.
	self countUp = true
		ifTrue: [sec := self ledSecond value.
			sec + 1 >= 59
				ifTrue: [self ledSecond value: 0.
					sec := 0.
					min := self ledMinute value.
					min + 1 >= 59
						ifTrue: [self ledMinute value: 0.
							min := 0.
							hr := self ledHour value.
							hr + 1 > 99
								ifTrue: [self pause.
									self player timeUp]
								ifFalse: [hr := hr + 1.
									self ledHour value: hr]]
						ifFalse: [min := min + 1.
							self ledMinute value: min]]
				ifFalse: [sec := sec + 1.
					self ledSecond value: sec].
			(hr = self aHour
					and: [min = self aMinute]
					and: [sec = self aSecond])
				ifTrue: [self pause.
					self player timeUp]]
		ifFalse: [sec := self ledSecond value.
			sec - 1 <= 0
				ifTrue: [min := self ledMinute value.
					min - 1 < 0
						ifTrue: [hr := self ledHour value.
							hr - 1 < 0
								ifTrue: [self ledSecond value: 0.
									self pause.
									self player timeUp]
								ifFalse: [self ledMinute value: 59.
									self ledSecond value: 59.
									hr := hr - 1.
									self ledHour value: hr]]
						ifFalse: [min := min - 1.
							self ledSecond value: 59.
							self ledMinute value: min]]
				ifFalse: [sec := sec - 1.
					self ledSecond value: sec]].
	self changed! !

Morph subclass: #PicturePuzzleMorph
	instanceVariableNames: 'labels rows columns realImageForm'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!PicturePuzzleMorph methodsFor: 'puzzle' stamp: 'lg 10/9/2007 21:30'!
checkCompletion
	(submorphs allSatisfy: #hasRightPiece) ifTrue: [self completed].! !

!PicturePuzzleMorph methodsFor: 'initialization' stamp: 'lg 10/11/2007 17:16'!
columns: c
	columns := c.! !

!PicturePuzzleMorph methodsFor: 'puzzle' stamp: 'lg 10/11/2007 17:27'!
completed
	self showSketch.! !

!PicturePuzzleMorph methodsFor: 'initialization' stamp: 'lg 10/13/2007 13:02'!
initialize
	super initialize.
	rows := 6.
	columns := 6.
	labels := #().
	self beSticky.! !

!PicturePuzzleMorph methodsFor: 'puzzle' stamp: 'lg 10/13/2007 13:02'!
labels: collection
	labels := collection.! !

!PicturePuzzleMorph methodsFor: 'puzzle' stamp: 'lg 10/10/2007 10:21'!
placeInEmptyBox: morph
	| empty |
	empty := submorphs detect: [ :m | (m isKindOf: PicturePuzzleBlockMorph) and: [m submorphs isEmpty] ].
	empty addMorph: morph.
! !

!PicturePuzzleMorph methodsFor: 'initialization' stamp: 'lg 10/11/2007 17:17'!
rescramble
	self scrambleForm: realImageForm.! !

!PicturePuzzleMorph methodsFor: 'initialization' stamp: 'lg 10/11/2007 17:38'!
rows: r
	rows := r.! !

!PicturePuzzleMorph methodsFor: 'puzzle' stamp: 'lg 10/14/2007 19:02'!
scrambleForm: form
	| letters tileWidth tileHeight morph sketch interior |
	self removeAllMorphs.
	letters := labels readStream.
	realImageForm := form.
	self extent: form extent.
	tileWidth := form width / columns.
	tileHeight := form height / rows.
 	(0 to: rows-1) do: [ :row | (0 to: columns-1) do: [ :col |
		morph := PicturePuzzleBlockMorph new.
		interior := (((row ~= 0) and: [row ~= (rows-1)]) and: [(col ~= 0) and: [col ~= (columns-1)]]).
		morph isInteriorBlock:interior.
		morph position: self position + ((col * tileWidth) @ (row * tileHeight)).
		morph extent: tileWidth @ tileHeight.
		morph layoutPolicy: TableLayout new.
		morph enableDrop: true.
		morph enableDrag: true.
		morph setProperty: #puzzlePosition toValue: row@col.
		self addMorph: morph.
		sketch := PicturePuzzlePieceMorph withForm: (form copy: (((col*tileWidth) @ (row*tileHeight)) extent: tileWidth@tileHeight)).
		sketch position: morph position.
		sketch setProperty: #puzzlePosition toValue: row@col.
		morph addMorph: sketch.
"		interior ifFalse: [sketch beSticky]."
		"Maybe label the morph"
		letters atEnd ifFalse: [sketch label: letters next].
	]].
	self shufflePieces.! !

!PicturePuzzleMorph methodsFor: 'puzzle' stamp: 'lg 10/11/2007 17:28'!
showSketch
	self showSketch: (SketchMorph withForm: realImageForm).
! !

!PicturePuzzleMorph methodsFor: 'puzzle' stamp: 'lg 10/11/2007 17:32'!
showSketch: sketch
	realImageForm := sketch form.
	sketch position: self position.
	self extent: sketch extent.
	self removeAllMorphs; addMorph: sketch.
! !

!PicturePuzzleMorph methodsFor: 'puzzle' stamp: 'lg 10/9/2007 21:25'!
shufflePieces
	| blocks pieces stream |
	blocks := self submorphs select: #isInteriorBlock.
	pieces := blocks collect: [ :block | block submorphs first ].
	stream := pieces shuffled readStream.
	blocks do: [ :block | block removeAllMorphs; addMorph: stream next ].
! !

Morph subclass: #Question
	instanceVariableNames: 'question answer image optionList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

Question subclass: #QuestionWithSound
	instanceVariableNames: 'sound'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!QuestionWithSound class methodsFor: 'as yet unclassified' stamp: 'Ram 1/31/2008 12:51'!
newQuestionWith: aQuestion sound: aSound
	|model|
	model:= self basicNew.

		


	

		! !

!QuestionWithSound methodsFor: 'as yet unclassified' stamp: 'Ram 1/31/2008 13:00'!
initialize
	super initialize.
	self sound:''! !

!QuestionWithSound methodsFor: 'accessing' stamp: 'Ram 1/31/2008 12:35'!
sound
	"Answer the value of sound"

	^ sound! !

!QuestionWithSound methodsFor: 'accessing' stamp: 'Ram 1/31/2008 12:35'!
sound: anObject
	"Set the value of sound"

	sound _ anObject! !

!Question methodsFor: 'as yet unclassified' stamp: 'Ram 3/11/2008 12:46'!
addOption: opt
	optionList add: opt.! !

!Question methodsFor: 'accessing' stamp: 'Ram 12/17/2007 13:24'!
answer
	"Answer the value of answer"

	^ answer! !

!Question methodsFor: 'accessing' stamp: 'Ram 12/17/2007 13:24'!
answer: anObject
	"Set the value of answer"

	answer _ anObject! !

!Question methodsFor: 'accessing' stamp: 'Ram 12/17/2007 13:24'!
image
	"Answer the value of image"

	^ image! !

!Question methodsFor: 'accessing' stamp: 'Ram 12/17/2007 13:24'!
image: anObject
	"Set the value of image"

	image _ anObject! !

!Question methodsFor: 'as yet unclassified' stamp: 'Ram 3/11/2008 12:46'!
initialize
	super initialize.
	optionList:= OrderedCollection new.! !

!Question methodsFor: 'accessing' stamp: 'Ram 12/17/2007 13:24'!
optionList
	"Answer the value of optionList"

	^ optionList! !

!Question methodsFor: 'accessing' stamp: 'Ram 12/17/2007 13:24'!
optionList: anObject
	"Set the value of optionList"

	optionList _ anObject! !

!Question methodsFor: 'accessing' stamp: 'Ram 12/17/2007 13:24'!
question
	"Answer the value of question"

	^ question! !

!Question methodsFor: 'accessing' stamp: 'Ram 12/17/2007 13:24'!
question: anObject
	"Set the value of question"

	question _ anObject! !

Morph subclass: #RipoffPatch
	instanceVariableNames: 'target'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!RipoffPatch methodsFor: '*ole' stamp: 'lg 9/24/2007 17:54'!
setTarget: morph
	target := morph.
	self position: morph position; extent: morph extent.! !

Morph subclass: #RipoffPatchMorph
	instanceVariableNames: 'target'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!RipoffPatchMorph methodsFor: 'initialization' stamp: 'lg 9/29/2007 13:03'!
initialize
	super initialize.
	self fillStyle: Color orange.
	self beSticky.
	self layoutPolicy: TableLayout new.
	self cellPositioning: #center; wrapCentering: #center; listCentering: #center.
	"XXX Add a text morph of a question mark"
	self cornerStyle: #rounded.
	! !

!RipoffPatchMorph methodsFor: 'initialization' stamp: 'lg 9/25/2007 10:19'!
setTarget: ripoffMorph 
	target := ripoffMorph.! !

!RipoffPatchMorph methodsFor: 'initialization' stamp: 'lg 9/25/2007 11:20'!
wantsDroppedMorph: morph event: evt
	^morph == target.

! !

Morph subclass: #SimpleHighlightMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!SimpleHighlightMorph methodsFor: 'as yet unclassified' stamp: 'lg 10/13/2007 09:40'!
handlesMouseOver: event
	^true! !

!SimpleHighlightMorph methodsFor: 'as yet unclassified' stamp: 'lg 10/13/2007 10:07'!
initialize
	super initialize.
	self color: Color transparent.! !

!SimpleHighlightMorph methodsFor: 'as yet unclassified' stamp: 'lg 10/13/2007 10:08'!
mouseEnter: event
	^self color: (Color yellow alpha: 0.25).! !

!SimpleHighlightMorph methodsFor: 'as yet unclassified' stamp: 'lg 10/13/2007 09:41'!
mouseLeave: event
	^self color: Color transparent.! !

!SampledSound class methodsFor: '*ole' stamp: 'lg 10/13/2007 21:02'!
addLibrarySoundsFromWaveDirectory: directory
	| files snd |
	files := (FileDirectory on: directory) fileNamesMatching: '*.wav'.
	files do: [ :file |
		snd := SampledSound fromWaveFileNamed: directory, '/', file.
		SampledSound addLibrarySoundNamed: (file copyUpTo: $.) samples: snd samples samplingRate: snd originalSamplingRate ].! !

StringMorph subclass: #AddingGameMorph
	instanceVariableNames: 'difficultyLevel tallyObject'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!AddingGameMorph class methodsFor: 'as yet unclassified' stamp: 'lg 11/26/2007 12:20'!
additionsToViewerCategoryAddingGame
	^#( #'adding game' (
			(slot tallyObject 'The object to appear in tally boxes' Player readWrite Player getTallyObject Player setTallyObject:)
			(slot difficultyLevel 'How hard to make the adding problems (higher is harder)' Number readWrite Player getDifficultyLevel Player setDifficultyLevel:)
			(slot rightAnswer 'The correct answer to the number problem' Number readOnly Player getRightAnswer unused unused)
			(command setupNewQuestion 'Put a new problem on the screen')
		))! !

!AddingGameMorph class methodsFor: 'as yet unclassified' stamp: 'lg 11/1/2007 09:29'!
authoringPrototype
	^super authoringPrototype contents: '+'; fontName: 'BitstreamVeraSansMono' size: 100.! !

!AddingGameMorph class methodsFor: 'as yet unclassified' stamp: 'lg 11/1/2007 11:50'!
descriptionForPartsBin
	^ self partName: 'AddingGame' categories: {'OLE'} documentation: 'Adding game quiz generator'! !

!AddingGameMorph methodsFor: 'game' stamp: 'lg 11/26/2007 11:52'!
answerForInputs: inputs
	| numbers |
	numbers := inputs collect: #gameValue.
	^self rules caseOf: { [#+] -> [numbers sum].  [#-] -> [numbers first - numbers second] }.
! !

!AddingGameMorph methodsFor: 'game' stamp: 'lg 11/11/2007 08:21'!
difficultyLevel
	^difficultyLevel! !

!AddingGameMorph methodsFor: 'game' stamp: 'lg 11/11/2007 08:21'!
difficultyLevel: level
	difficultyLevel := level! !

!AddingGameMorph methodsFor: 'game' stamp: 'lg 11/26/2007 12:27'!
getRightAnswer
	^self answerForInputs: World gameInputs.! !

!AddingGameMorph methodsFor: 'as yet unclassified' stamp: 'lg 11/1/2007 09:47'!
initializeToStandAlone
	super initializeToStandAlone.
	self contents: '+'; fontName: 'BitstreamVeraSans' size: 100.! !

!AddingGameMorph methodsFor: 'game' stamp: 'lg 11/26/2007 12:50'!
rules
	self contents = '+' ifTrue: [^#+].
	self contents = '-' ifTrue: [^#-].
	^nil.! !

!AddingGameMorph methodsFor: 'game' stamp: 'lg 11/26/2007 12:16'!
setupInputs: inputs
	| answer left right |
	self rules caseOf:
	{ [#+] -> [
		answer := (2 to: 9) atRandom.
		left := (1 to: answer - 1) atRandom.
		right := answer - left. ].
	   [#-] -> [
		answer := (1 to: 8) atRandom.
		left := (answer + 1 to: 9) atRandom.
		right := left - answer. ]
	}.
	inputs first setGameValue: left tallyObject: tallyObject.
	inputs second setGameValue: right tallyObject: tallyObject.
! !

!AddingGameMorph methodsFor: 'game' stamp: 'lg 11/26/2007 12:51'!
setupNewProblem
	| choices inputs answer choiceValues |
	self rules ifNil: [^self inform: 'Operator is not valid: ' , self contents].
	inputs := World gameInputs.
	choices := World gameChoices.
	inputs ifEmpty: [^self inform: 'You have to specify some inputs first'].
	choices ifEmpty: [^self inform: 'You have to specify some choices first'].
	self setupInputs: inputs.
"	inputs do: [ :choice | choice setGameValue: (1 to: 4) atRandom tallyObject: tallyObject]."
	answer := self answerForInputs: inputs.
"	answer := (inputs collect: #gameValue) sum."
	choiceValues := ( {answer} , ((2 to: 8) asArray shuffled without: answer) ) readStream.
	choices shuffled do: [ :input | input setGameValue: choiceValues next tallyObject: tallyObject].! !

!AddingGameMorph methodsFor: 'game' stamp: 'lg 11/11/2007 08:10'!
tallyObject
	^tallyObject! !

!AddingGameMorph methodsFor: 'game' stamp: 'lg 11/11/2007 08:10'!
tallyObject: morph
	tallyObject := morph.! !

AddingGameMorph subclass: #MinusGameMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!MinusGameMorph class methodsFor: 'as yet unclassified' stamp: 'lg 11/24/2007 13:42'!
authoringPrototype
	^super authoringPrototype contents: '-'; fontName: 'BitstreamVeraSansMono' size: 100.! !

!MinusGameMorph class methodsFor: 'as yet unclassified' stamp: 'lg 11/24/2007 13:37'!
descriptionForPartsBin
	^ self partName: 'SubtractingGame' categories: {'OLE'} documentation: 'Subtracting game quiz generator'! !

!MinusGameMorph methodsFor: 'as yet unclassified' stamp: 'lg 11/24/2007 13:38'!
initializeToStandAlone
	super initializeToStandAlone contents: '-'.! !

!Player methodsFor: '*ole' stamp: 'lg 11/11/2007 08:25'!
getDifficultyLevel
	^costume difficultyLevel! !

!Player methodsFor: '*ole' stamp: 'lg 10/29/2007 17:44'!
getGameInstrumentType
	^costume gameInstrumentType.! !

!Player methodsFor: '*ole' stamp: 'lg 10/29/2007 15:32'!
getGameValue
	^costume gameValue! !

!Player methodsFor: '*ole' stamp: 'lg 11/26/2007 12:37'!
getRightAnswer
	^costume getRightAnswer.! !

!Player methodsFor: '*ole' stamp: 'lg 11/11/2007 08:24'!
getTallyObject
	^costume tallyObject! !

!Player methodsFor: '*ole' stamp: 'lg 10/30/2007 17:46'!
sayNumber: n 
	self beep: n asString! !

!Player methodsFor: '*ole' stamp: 'lg 11/11/2007 08:25'!
setDifficultyLevel: n
	^costume difficultyLevel: n! !

!Player methodsFor: '*ole' stamp: 'lg 10/29/2007 17:44'!
setGameInstrumentType: type
	costume gameInstrumentType: type.! !

!Player methodsFor: '*ole' stamp: 'lg 10/29/2007 15:32'!
setGameValue: value
	costume gameValue: value! !

!Player methodsFor: '*ole' stamp: 'lg 11/11/2007 08:23'!
setTallyObject: morph
	^costume tallyObject: morph.! !

!Player methodsFor: '*ole' stamp: 'lg 11/1/2007 10:33'!
setupNewQuestion
	costume setupNewProblem! !

!Player methodsFor: '*ole' stamp: 'lg 10/30/2007 17:28'!
waitForSeconds: n 
	costume waitForSeconds: n.! !

PasteUpMorph subclass: #ObjectSetMorph
	instanceVariableNames: 'objects'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!ObjectSetMorph methodsFor: 'as yet unclassified' stamp: 'lg 10/11/2007 15:33'!
initialize
	super initialize.
	self resetObjectSequence.! !

!ObjectSetMorph methodsFor: 'objects' stamp: 'lg 10/11/2007 15:32'!
installNewTallyMorph
	| object |
	objects atEnd ifTrue: [^self].
	object := objects next.
	World allMorphsDo: [ :m | (m isKindOf: TallyMorph) ifTrue: [m setTallyObject: object] ].! !

!ObjectSetMorph methodsFor: 'as yet unclassified' stamp: 'lg 10/11/2007 15:31'!
resetObjectSequence
	objects := self submorphs readStream.! !

!PasteUpMorph class methodsFor: '*ole-scripting' stamp: 'lg 10/31/2007 16:07'!
additionsToViewerCategoryGameInstrument
	^ #().
! !

!PasteUpMorph methodsFor: '*OLE' stamp: 'ss 10/5/2007 13:52'!
animalNames
	^self  submorphs collect:
	[:morph| morph externalName]! !

!PasteUpMorph methodsFor: '*ole-game-element' stamp: 'lg 10/29/2007 15:55'!
gameValue
	^self submorphs size! !

!PasteUpMorph methodsFor: '*ole-flaps' stamp: 'lg 12/4/2007 11:11'!
hideFlaps
	self submorphs do: [ :m | m class = FlapTab ifTrue: [m hide]].! !

!PasteUpMorph methodsFor: '*ole-override' stamp: 'lg 12/23/2007 21:37'!
installFlaps
	"Get flaps installed within the bounds of the receiver"

	| localFlapTabs |
	Project current assureFlapIntegrity.
	self addGlobalFlaps.
	localFlapTabs := self localFlapTabs.
	localFlapTabs do: [:each | each visible: false].

	Preferences eToyFriendly ifTrue: [
		ProgressInitiationException display: 'Building Viewers...' translated
			during: [:bar |
				localFlapTabs keysAndValuesDo: [:i :each |
					each adaptToWorld.
					each setVisibilityByMode.
					self displayWorld.
					bar value: i / self localFlapTabs size]].
	] ifFalse: [
		localFlapTabs keysAndValuesDo: [:i :each |
			each adaptToWorld.
			each setVisibilityByMode.
			self displayWorld]].

	OLE updateSugarToolbar.
	self assureFlapTabsFitOnScreen.
	self bringTopmostsToFront! !

!PasteUpMorph methodsFor: '*OLE' stamp: 'ss 10/5/2007 16:28'!
makeAnimalButton:label
	^AnimalButton new label:label.
! !

!PasteUpMorph methodsFor: '*ole-game' stamp: 'lg 12/24/2007 09:58'!
setGameValue: n tallyObject: object
	self removeAllMorphs.
	n timesRepeat: [ self addMorph: object costume duplicate beSticky ].
	self spreadMorphs.! !

!PasteUpMorph methodsFor: '*ole-game' stamp: 'lg 11/1/2007 08:36'!
setGameValue: n
	| object |
	object := self submorphs first.
	self removeAllMorphs.
	n timesRepeat: [ self addMorph: object duplicate ].
	self spreadMorphs.! !

!PasteUpMorph methodsFor: '*OLE' stamp: 'ss 10/5/2007 15:32'!
showAnimalNames
	|row|
	row:= AlignmentMorph inARow:
			(self animalNames collect:[:label| self makeAnimalButton:label]).
	row openInWorld; position: 200@600
       ! !

!PasteUpMorph methodsFor: '*ole-project loading' stamp: 'lg 12/18/2007 07:48'!
showLinksToProjectsInDirectory: dirName 
	self removeAllMorphs.
	self layoutPolicy: TableLayout new; listDirection: #topToBottom; cellInset: 10; cellPositioning: #topLeft.
	self addLinksToProjectsInDirectory: dirName.
! !

!PasteUpMorph methodsFor: '*ole-game-element' stamp: 'lg 10/29/2007 15:59'!
tallyObject
	^self valueOfProperty: #tallyObject! !

!PasteUpMorph methodsFor: '*ole-game-element' stamp: 'lg 10/29/2007 15:59'!
tallyObject: object
	^self setProperty: #tallyObject toValue: object! !

PasteUpMorph subclass: #PicturePuzzleBlockMorph
	instanceVariableNames: 'interiorBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!PicturePuzzleBlockMorph methodsFor: 'puzzle' stamp: 'lg 10/9/2007 21:43'!
hasRightPiece
	^self submorphs anySatisfy: [ :morph | (self valueOfProperty: #puzzlePosition) = (morph valueOfProperty: #puzzlePosition)].
 ! !

!PicturePuzzleBlockMorph methodsFor: 'puzzle' stamp: 'lg 10/11/2007 17:39'!
initialize
	super initialize.
	self color: World color.! !

!PicturePuzzleBlockMorph methodsFor: 'puzzle' stamp: 'lg 10/9/2007 21:24'!
isInteriorBlock
	^interiorBlock.! !

!PicturePuzzleBlockMorph methodsFor: 'puzzle' stamp: 'lg 10/9/2007 21:23'!
isInteriorBlock: flag 
	interiorBlock := flag.! !

PasteUpMorph subclass: #ProjectDirectoryMorph
	instanceVariableNames: 'directory'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!ProjectDirectoryMorph class methodsFor: 'projects' stamp: 'lg 12/20/2007 12:44'!
expungeChildProjects
	self shouldBeImplemented! !

!ProjectDirectoryMorph class methodsFor: 'class initialization' stamp: 'lg 1/29/2008 13:06'!
startUp
	Smalltalk isMorphic ifTrue:
		[World allMorphsDo:
			[:m | (m isKindOf: ProjectDirectoryMorph) ifTrue: [m updateDirectoryListing]]].! !

!ProjectDirectoryMorph class methodsFor: 'updating' stamp: 'lg 12/18/2007 16:49'!
updateAllDirectoryListings
	WorldState addDeferredUIMessage: [Project removeAllButCurrent.].
	World allMorphsDo:
		[ :m | (m isKindOf: self) ifTrue: [m updateDirectoryListing] ].! !

!ProjectDirectoryMorph class methodsFor: 'projects' stamp: 'lg 12/20/2007 17:55'!
updateDirectoryListings
	World allMorphsDo: [ :m |
		(m isKindOf: self) ifTrue: [m updateDirectoryListing] ]! !

!ProjectDirectoryMorph methodsFor: 'initialization' stamp: 'ss 4/11/2008 15:07'!
addLinksToProjectsInDirectory: dirName 
	| dir subdirNames |
	dir := FileDirectory on: (Smalltalk imagePath, FileDirectory slash, dirName).
	subdirNames := dir directoryNames sort collect: [ :sub | dirName, FileDirectory slash, sub ].
	subdirNames do: [ :subdir |
		(Project linksForDirectory: subdir) ifNotNilDo:
			[ :linksMorph | self addMorphBack: linksMorph ] ]! !

!ProjectDirectoryMorph methodsFor: 'initialization' stamp: 'lg 12/18/2007 08:09'!
initialize
	super initialize.
	self layoutPolicy: TableLayout new; listDirection: #topToBottom; cellInset: 10; cellPositioning: #topLeft.! !

!ProjectDirectoryMorph methodsFor: 'initialization' stamp: 'lg 12/20/2007 20:42'!
showDirectory: dirName
	directory := dirName.
	self removeAllMorphs.
	self addLinksToProjectsInDirectory: dirName.! !

!ProjectDirectoryMorph methodsFor: 'initialization' stamp: 'lg 1/29/2008 12:36'!
startUp
	self updateDirectoryListing! !

!ProjectDirectoryMorph methodsFor: 'initialization' stamp: 'lg 1/29/2008 12:36'!
updateDirectoryListing
	directory ifNotNil: [self showDirectory: directory].! !

!ProjectDirectoryMorph class methodsFor: 'class initialization' stamp: 'lg 1/29/2008 12:35'!
initialize
	super initialize.
	Smalltalk addToStartUpList: ProjectDirectoryMorph.
! !

PasteUpMorph subclass: #QuestionListMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

PasteUpMorph subclass: #QuestionSetMorph
	instanceVariableNames: 'questions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!QuestionSetMorph methodsFor: 'as yet unclassified' stamp: 'lg 10/14/2007 08:20'!
questions
	^(self submorphs collect: #duplicate) readStream.! !

PasteUpMorph subclass: #TallyMorph
	instanceVariableNames: 'tallyObject'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

TallyMorph subclass: #TallyAnswerMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!TallyAnswerMorph methodsFor: 'as yet unclassified' stamp: 'lg 10/11/2007 11:41'!
handlesMouseDown: event
	^true! !

!TallyAnswerMorph methodsFor: 'as yet unclassified' stamp: 'lg 10/11/2007 11:38'!
isGameChoice
	^true! !

!TallyAnswerMorph methodsFor: 'as yet unclassified' stamp: 'lg 10/11/2007 11:37'!
isGameInput
	^false! !

!TallyAnswerMorph methodsFor: 'as yet unclassified' stamp: 'lg 10/11/2007 11:41'!
mouseDown: event
	NumberGame answer: self getGameValue.! !

!TallyMorph methodsFor: 'game' stamp: 'lg 10/14/2007 11:55'!
getGameValue
	^ (self submorphs select: [ :m | (m isKindOf: SimpleHighlightMorph) not]) size.
! !

!TallyMorph methodsFor: 'game' stamp: ''!
increment
	self setGameValue: self getGameValue + 1! !

!TallyMorph methodsFor: 'initialization' stamp: 'lg 10/11/2007 12:22'!
initialize
	super initialize.
! !

!TallyMorph methodsFor: 'game' stamp: ''!
isGameInput
	^ true! !

!TallyMorph methodsFor: 'game' stamp: 'lg 10/14/2007 11:58'!
removeAllObjects
	self submorphs do: [ :m | (m isKindOf: SimpleHighlightMorph) ifFalse: [self removeMorph: m]].! !

!TallyMorph methodsFor: 'game' stamp: 'lg 10/14/2007 12:02'!
setGameValue: n
	self removeAllObjects.
	n timesRepeat: [ self addMorph: tallyObject duplicate beSticky].
	self spreadMorphs.! !

!TallyMorph methodsFor: 'objects' stamp: 'lg 10/11/2007 11:29'!
setTallyObject: object
	tallyObject := object.! !

ScriptableButton subclass: #AnimalButton
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!AnimalButton methodsFor: 'as yet unclassified' stamp: 'ss 10/5/2007 16:34'!
doButtonAction
	AnimalGame answer:self label! !

ScriptableButton subclass: #GameButton
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!GameButton methodsFor: 'game' stamp: 'lg 10/2/2007 15:37'!
doButtonAction
	NumberGame answer: (self submorphs first contents asInteger)! !

!GameButton methodsFor: 'as yet unclassified' stamp: 'lg 10/2/2007 15:34'!
isGameChoice
	^true! !

!GameButton methodsFor: 'game' stamp: 'lg 10/2/2007 15:45'!
setGameValue: n 
	self submorphs first contents: n asString.
	self fixYourLayout.! !

ScriptableButton subclass: #TextButton
	instanceVariableNames: 'isClicked'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!TextButton methodsFor: 'as yet unclassified' stamp: 'Ram 4/8/2008 09:48'!
handlesMouseOver: evt
^true! !

!TextButton methodsFor: 'as yet unclassified' stamp: 'Ram 4/9/2008 12:11'!
initialize
	super initialize.
	self color:(Color r: 0.878 g: 0.94 b: 0.976).
	self isClicked: false.! !

!TextButton methodsFor: 'accessing' stamp: 'Ram 4/8/2008 11:32'!
isClicked
	"Answer the value of isClicked"

	^ isClicked! !

!TextButton methodsFor: 'accessing' stamp: 'Ram 4/8/2008 11:32'!
isClicked: anObject
	"Set the value of isClicked"

	isClicked _ anObject! !

!TextButton methodsFor: 'as yet unclassified' stamp: 'Ram 4/9/2008 10:30'!
mouseDown: evt
	| myText mp |
	(self isClicked=true) ifFalse:[
		myText:=World allMorphs select:[:each| (each isKindOf:UserText )
					and: ['myChar' match: each externalName]].
		myText:= myText at:1.
		mp:= myText player.
		mp receiveMessage: self label.
		self isClicked: true.
	]
	! !

!TextButton methodsFor: 'as yet unclassified' stamp: 'Ram 4/8/2008 11:36'!
mouseEnter: evt
	(self isClicked=true) ifFalse:[
		self color: Color white.
	]! !

!TextButton methodsFor: 'as yet unclassified' stamp: 'Ram 4/9/2008 11:26'!
mouseLeave: evt
	(self isClicked=true) ifFalse:[
		self color:(Color r: 0.878 g: 0.94 b: 0.976).
	]! !

!TextButton methodsFor: 'as yet unclassified' stamp: 'Ram 4/9/2008 12:12'!
resetButton
	self isClicked:false.
	self color:(Color r: 0.878 g: 0.94 b: 0.976)..
	! !

SugarNavTab subclass: #OLESugarNavTab
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!SugarNavTab methodsFor: '*ole' stamp: 'lg 12/4/2007 11:38'!
setVisibilityByMode
	self visible: true! !

SymbolListType subclass: #GameInstrumentType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!GameInstrumentType methodsFor: 'initialization' stamp: 'lg 10/31/2007 16:00'!
initialize
	super initialize.
	self vocabularyName: #GameInstrumentType.
	symbols := #(none choice input).! !

!GameInstrumentType methodsFor: 'queries' stamp: 'lg 10/29/2007 14:06'!
representsAType
	^true.! !

!True methodsFor: '*ole' stamp: 'lg 10/29/2007 12:36'!
yesNoString
	^'<yes>'! !

!FileDirectory methodsFor: '*ole' stamp: 'lg 10/13/2007 20:18'!
importWaveSounds
	self shouldBeImplemented! !

!TheWorldMenu methodsFor: '*ole' stamp: 'lg 11/24/2007 12:59'!
buildWorldMenu
	"Build the menu that is put up when the screen-desktop is clicked on"

	| menu |
	menu _ MenuMorph new defaultTarget: self.
	menu commandKeyHandler: self.
	self colorForDebugging: menu.
	menu addStayUpItem.
	self fillIn: menu from: {
		{'OLE...' translated. { self . #oleDo }. 'open the Open Learning Exchange extensions menu' }.
		nil.
		{'previous project' translated. { #myWorld . #goBack }. 'return to the most-recently-visited project' translated}.
		{'jump to project...' translated. { #myWorld . #jumpToProject }. 'put up a list of all projects, letting me choose one to go to' translated}.
		{'save project on file...' translated. { #myWorld  . #saveOnFile }. 'save this project on a file' translated}.
		{'load project from file...' translated. { self  . #loadProject }. 'load a project from a file' translated}.
		nil}.
	myWorld addUndoItemsTo: menu.

		self fillIn: menu from: {
		{'restore display (r)' . { World . #restoreMorphicDisplay }. 'repaint the screen -- useful for removing unwanted display artifacts, lingering cursors, etc.' translated}.
		nil}.
	Preferences simpleMenus ifFalse:
		[self fillIn: menu from: { 
			{'open...' translated. { self  . #openWindow } }.
			{'windows...' translated. { self  . #windowsDo } }.
			{'changes...' translated. { self  . #changesDo } }}].
	self fillIn: menu from: { 
		{'help...' translated. { self  . #helpDo }.  'puts up a menu of useful items for updating the system, determining what version you are running, and much else' translated}.
		{'appearance...' translated. { self  . #appearanceDo }. 'put up a menu offering many controls over appearance.' translated}}.

	Preferences simpleMenus ifFalse:
		[self fillIn: menu from: {
			{'do...' translated. { Utilities . #offerCommonRequests} . 'put up an editible list of convenient expressions, and evaluate the one selected.' translated}}].

	self fillIn: menu from: { 
		nil.
		{'objects (o)' translated. { #myWorld . #activateObjectsTool } . 'A tool for finding and obtaining many kinds of objects' translated}.
		{'new morph...' translated. { self  . #newMorph }. 'Offers a variety of ways to create new objects' translated}.
		nil.
		{'authoring tools...' translated. { self  . #scriptingDo } . 'A menu of choices useful for authoring' translated}.
		{'playfield options...' translated. { self  . #playfieldDo } . 'A menu of options pertaining to this object as viewed as a playfield' translated}.
		{'flaps...' translated. { self . #flapsDo } . 'A menu relating to use of flaps.  For best results, use "keep this menu up"' translated}.
		{'projects...' translated. { self  . #projectDo }. 'A menu of commands relating to use of projects' translated}}.
	Preferences simpleMenus ifFalse:
		[self fillIn: menu from: { 
			{'print PS to file...' translated. { self  . #printWorldOnFile } . 'write the world into a postscript file' translated}.
			{'debug...' translated. { self  . #debugDo } . 'a menu of debugging items' translated}}].
	self fillIn: menu from: { 
		nil.
		{'save' translated. { SmalltalkImage current  . #saveSession } . 'save the current version of the image on disk' translated}.
		{'save as...' translated. { SmalltalkImage current . #saveAs }. 'save the current version of the image on disk under a new name.' translated}.
		{'save as new version' translated. { SmalltalkImage current . #saveAsNewVersion }. 'give the current image a new version-stamped name and save it under that name on disk.' translated}.
		{'save and quit' translated. { self  . #saveAndQuit } . 'save the current image on disk, and quit out of Squeak.' translated}.
		{'quit' translated. { self  . #quitSession } . 'quit out of Squeak.' translated}}.

	^ menu! !

!TheWorldMenu methodsFor: '*ole' stamp: 'lg 11/24/2007 12:22'!
oleDo
	self doPopUp: self oleMenu.! !

!TheWorldMenu methodsFor: '*ole' stamp: 'lg 12/18/2007 12:16'!
oleMenu
	| menu |
	menu := self menu: 'Open Learning Exchange'.
	^ self fillIn: menu from: {
		{ 'author mode' translated. { OLE. #authorMode } }.
		{ 'user mode' translated. { OLE. #userMode } }.
		nil.
		{ 'toggle flaps' translated. { self. #toggleFlaps } }.
		nil.
		{ 'deploy' translated. { OLE. #deploy } }
	}
! !

!TheWorldMenu methodsFor: '*ole' stamp: 'lg 11/24/2007 13:13'!
toggleFlaps
	| wasHidden |
	wasHidden := World submorphs noneSatisfy: [ :m | m class = FlapTab and: [ m visible ] ].
	World submorphs do: [  :m | m class = FlapTab ifTrue: [ m visible: wasHidden]].! !

!Symbol methodsFor: '*ole' stamp: 'jwl 10/1/2007 17:40'!
value: x 
	^ x perform: self.
! !

!FlapTab methodsFor: '*ole' stamp: 'lg 12/4/2007 11:36'!
setVisibilityByMode
	self visible: OLE isAuthorMode.! !

!Number methodsFor: '*ole' stamp: 'lg 10/11/2007 12:02'!
roundedUp
	^self = self asInteger ifTrue: [self asInteger] ifFalse: [self asInteger + 1].! !

UserText subclass: #InputFieldMorph
	instanceVariableNames: 'maxLength'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!InputFieldMorph commentStamp: 'sw 2/8/2008 01:28' prior: 0!
A type-in field accepting only a given number of digits.!

InputFieldMorph subclass: #FLText
	instanceVariableNames: 'tallyObject'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!FLText methodsFor: 'as yet unclassified' stamp: 'a 3/7/2008 17:24'!
initialize

super initialize.
self maxLength:1.
self setCharacters: ''.
self borderWidth:2.
! !

InputFieldMorph subclass: #InputFieldMorphWithBGColor
	instanceVariableNames: 'myCharacter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!InputFieldMorphWithBGColor methodsFor: 'as yet unclassified' stamp: 'Ram 4/3/2008 17:20'!
checkAnswer
	self getCharacters size>0 
	ifTrue:[
		self getCharacters= self myCharacter 
			ifTrue:[^true]
			ifFalse:[^false].
			]
	ifFalse:[^false]
! !

!InputFieldMorphWithBGColor methodsFor: 'as yet unclassified' stamp: 'Ram 4/2/2008 17:14'!
keyStroke: evt 
	super keyStroke:evt.
	self getCharacters size>0 
	ifTrue:[
		self getCharacters= self myCharacter 
			ifTrue:[ self backgroundColor:(Color r: 1.0 g: 1.0 b: 1.0)]
			ifFalse:[self backgroundColor:(Color r: 1.0 g: 1.0 b: 0.0)].
			]
	ifFalse:[self backgroundColor:(Color r: 1.0 g: 1.0 b: 1.0)]
! !

!InputFieldMorphWithBGColor methodsFor: 'accessing' stamp: 'Ram 4/2/2008 16:59'!
myCharacter
	"Answer the value of myCharacter"

	^ myCharacter! !

!InputFieldMorphWithBGColor methodsFor: 'accessing' stamp: 'Ram 4/2/2008 16:59'!
myCharacter: anObject
	"Set the value of myCharacter"

	myCharacter _ anObject! !

!InputFieldMorph class methodsFor: 'parts bin' stamp: 'sw 2/8/2008 01:36'!
descriptionForPartsBin
	"If the receiver is a member of a class that would like to be represented in a parts bin, answer the name by which it should be known, and a documentation string to be provided, for example, as balloon help.  When the 'nativitySelector' is sent to the 'globalReceiver', it is expected that some kind of Morph will result.  The parameters used in the implementation below are for documentation purposes only!!"

	^ self partName:	'Digits Field' translatedNoop
		categories:		{'OLE' translatedNoop}
		documentation:	'A type-in field whose contents are limited to a given number of digits' translatedNoop! !

!InputFieldMorph methodsFor: 'menu' stamp: 'sw 2/8/2008 00:55'!
addCustomMenuItems: aCustomMenu hand: aHandMorph
	"Add object-specific menu items to a menu."

	super addCustomMenuItems: aCustomMenu hand: aHandMorph.
	aCustomMenu add: 'set number of digits...' translated target: self action: #setNumberOfDigits! !

!InputFieldMorph methodsFor: 'initialization' stamp: 'ss 2/14/2008 14:15'!
initialize
	"Initialize the receiver."

	self setProperty: #defaultContents toValue: '42' asText.
	super initialize.
	maxLength := 2.
	self width: 60.
	self beAllFont: (StrikeFont familyName: 'BitStreamVeraSans' size: 40)

"
DigitsField initializedInstance openInHand
"! !

!InputFieldMorph methodsFor: 'event handling' stamp: 'a 3/9/2008 12:17'!
keyStroke: evt 
	"Handle a keystroke event."

	| newSel key |
	key := evt keyCharacter.

	evt commandKeyPressed ifTrue: [^ self rejectKeystroke].

	(#(8 13 28 29) includes: key charCode) ifTrue: [^ super keyStroke: evt].

	"key isDigit ifFalse: [^ self rejectKeystroke]."
	(self editor selection size = 0 and: [text string size >= maxLength]) ifTrue: [^ self rejectKeystroke].

	super keyStroke: evt.
	ActiveHand keyboardFocus == self ifFalse: [self releaseEditor. ^ self].
	newSel := self editor selectionInterval.	"restore editor state"
	self refreshParagraph.
	self editor selectFrom: newSel first to: newSel last! !

!InputFieldMorph methodsFor: 'accessing' stamp: 'sw 2/8/2008 01:29'!
maxLength: aLength
	"Set the maximum number of digits accepted."

	maxLength := aLength! !

!InputFieldMorph methodsFor: 'as yet unclassified' stamp: 'a 3/5/2008 13:24'!
obtainKeyboardFocus
	ActiveHand keyboardFocus: self renderedMorph.
	self renderedMorph editor selectAll! !

!InputFieldMorph methodsFor: 'event handling' stamp: 'ss 2/14/2008 13:02'!
rejectKeystroke
	"Reject keystroke input"

	"Beeper beep.
	self flashBounds"	
	^self ! !

!InputFieldMorph methodsFor: 'menu actdions' stamp: 'sw 2/8/2008 01:42'!
setNumberOfDigits
	"Put up a dialog telling the user the current number of digits specified and allowing him to change that setting."

	| result |
	result := FillInTheBlank request: 'Type number of digits desired' translated initialAnswer: maxLength printString.
	result ifEmpty: [^ self].
	result isAllDigits ifFalse: [^ self inform: 'type digits only please' translated].
	maxLength := result.
	text string size > maxLength ifTrue:
		[text replaceFrom: maxLength + 1 to: text string size with: ''.
		self releaseParagraph; paragraph]! !

UserText subclass: #NepaliTextMorph
	instanceVariableNames: 'maxLength'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!NepaliTextMorph class methodsFor: 'as yet unclassified' stamp: 'Ram 3/18/2008 13:23'!
descriptionForPartsBin
	"If the receiver is a member of a class that would like to be represented in a parts bin, answer the name by which it should be known, and a documentation string to be provided, for example, as balloon help.  When the 'nativitySelector' is sent to the 'globalReceiver', it is expected that some kind of Morph will result.  The parameters used in the implementation below are for documentation purposes only!!!!"

	^ self partName:	'InputField' translatedNoop
		categories:		{'OLE' translatedNoop}
		documentation:	'A type-in field whose contents are limited to a given number of letters' translatedNoop
! !

!NepaliTextMorph methodsFor: 'as yet unclassified' stamp: 'Ram 3/18/2008 13:17'!
addCustomMenuItems: aCustomMenu hand: aHandMorph
	"Add object-specific menu items to a menu."

	super addCustomMenuItems: aCustomMenu hand: aHandMorph.
	aCustomMenu add: 'set number of digits...' translated target: self action: #setNumberOfDigits
! !

!NepaliTextMorph methodsFor: 'as yet unclassified' stamp: 'Ram 3/18/2008 13:29'!
initialize
	"Initialize the receiver."

	self setProperty: #defaultContents toValue: '00' asText.
	super initialize.
	maxLength := 5.
	self beAllFont: (StrikeFont familyName: 'DevanagariNew' size: 60).
	self width: 50.
	self borderWidth:1.! !

!NepaliTextMorph methodsFor: 'as yet unclassified' stamp: 'Ram 3/18/2008 13:18'!
keyStroke: evt 
	"Handle a keystroke event."

	| newSel key |
	key := evt keyCharacter.

	evt commandKeyPressed ifTrue: [^ super keyStroke: evt].

	(#(8 13 28 29) includes: key charCode) ifTrue: [^ super keyStroke: evt].

	"key isDigit ifFalse: [^ self rejectKeystroke]."
	(self editor selection size = 0 and: [text string size >= maxLength]) ifTrue: [^ self rejectKeystroke].

	super keyStroke: evt.
	ActiveHand keyboardFocus == self ifFalse: [self releaseEditor. ^ self].
	newSel := self editor selectionInterval.	"restore editor state"
	self refreshParagraph.
	self editor selectFrom: newSel first to: newSel last! !

!NepaliTextMorph methodsFor: 'as yet unclassified' stamp: 'Ram 3/18/2008 13:19'!
maxLength: aLength
	"Set the maximum number of digits accepted."

	maxLength := aLength
! !

!NepaliTextMorph methodsFor: 'as yet unclassified' stamp: 'Ram 3/18/2008 13:18'!
rejectKeystroke
	"Reject keystroke input"
	^self ! !

!False methodsFor: '*ole' stamp: 'lg 10/29/2007 12:35'!
yesNoString
	^'<no>'.! !

EllipseMorph subclass: #EllipticGameInputMorph
	instanceVariableNames: 'label'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!EllipticGameInputMorph methodsFor: 'as yet unclassified' stamp: 'lg 10/12/2007 06:38'!
getGameValue
	^label contents asInteger.! !

!EllipticGameInputMorph methodsFor: 'as yet unclassified' stamp: 'lg 10/12/2007 05:27'!
handlesMouseDown: event
	^true! !

!EllipticGameInputMorph methodsFor: 'as yet unclassified' stamp: 'lg 10/14/2007 12:06'!
handlesMouseOver: event
	^true! !

!EllipticGameInputMorph methodsFor: 'as yet unclassified' stamp: 'lg 10/12/2007 05:30'!
initialize
	super initialize.
	label := StringMorph new.
	label  contents: '0'; center: self center.
	self addMorph: label.! !

!EllipticGameInputMorph methodsFor: 'as yet unclassified' stamp: 'lg 10/12/2007 05:34'!
isGameChoice
	^true! !

!EllipticGameInputMorph methodsFor: 'as yet unclassified' stamp: 'lg 10/12/2007 05:33'!
layoutChanged
	label center: self center.
	^super layoutChanged.! !

!EllipticGameInputMorph methodsFor: 'as yet unclassified' stamp: 'lg 10/12/2007 06:39'!
mouseDown: event
	NumberGame answer: self getGameValue.! !

!EllipticGameInputMorph methodsFor: 'as yet unclassified' stamp: 'lg 10/14/2007 12:06'!
mouseEnter: event
	self color: (Color yellow alpha: 0.25).! !

!EllipticGameInputMorph methodsFor: 'as yet unclassified' stamp: 'lg 10/14/2007 12:06'!
mouseLeave: event
	self color: (Color transparent).! !

!EllipticGameInputMorph methodsFor: 'as yet unclassified' stamp: 'lg 10/12/2007 05:35'!
setGameValue: n
	label contents: n asString.! !

AlignmentMorph subclass: #DigitChooserMorph
	instanceVariableNames: 'value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!DigitChooserMorph class methodsFor: 'as yet unclassified' stamp: 'lg 9/21/2007 14:07'!
additionsToViewerCategories
	^ #( (basic ((slot numericValue 'The most recently pressed digit (or zero, initially).' Number readWrite Player getNumericValue Player setNumericValue:))))! !

!DigitChooserMorph methodsFor: '*ole' stamp: 'lg 9/21/2007 13:37'!
addButtonRows
	| row |
	#( (1 2 3) (4 5 6) (7 8 9) ) do:
		[ :digits |
			row := AlignmentMorph newRow vResizing: #spaceFill; cellInset: 3; yourself.
			digits do: [ :d | row addMorphBack: (self buttonFor: d)].
			self addMorph: row]! !

!DigitChooserMorph methodsFor: '*ole' stamp: 'lg 10/1/2007 16:45'!
buttonFor: digit 
	^ SimpleButtonMorph new target: NumberGame;
		label: digit asString font: Preferences standardEToysButtonFont;
		actionSelector: #answer:;
		arguments: { digit };
		hResizing: #spaceFill;
		vResizing: #spaceFill.! !

!DigitChooserMorph methodsFor: '*ole' stamp: 'lg 9/21/2007 13:46'!
initialize
	super initialize.
	self extent: 300@300.
	self layoutPolicy: TableLayout new.
	self listDirection: #bottomToTop.
	self vResizing: #spaceFill.
	self cellInset: 3.
	self cellPositioning: #center.
	self listCentering: #justified.
	self wrapCentering: #justified.
	borderWidth := 2.
	self addButtonRows.
! !

!ProjectLoading class methodsFor: '*ole-public' stamp: 'lg 11/25/2007 11:10'!
findProjectFileNamed: projectName recursivelyInDirectory: directoryName
	| directory entries subdirs filename |
	directory := FileDirectory on: directoryName.
	entries := FileList2 projectOnlySelectionMethod: directory entries.
	entries := entries detect: [:each | (Project parseProjectFileName: each first) first = projectName] ifNone: [nil].
	entries isNil ifFalse: [^entries first].
	"Recurse"
	subdirs := directory directoryNames collect: [ :subdir | directory fullPathFor: subdir].
	subdirs do: [:dir | filename := self findProjectFileNamed: projectName recursivelyInDirectory: dir.
						 filename isNil ifFalse: [^(FileDirectory on: dir) fullPathFor: filename]].
	^nil.
! !

!ProjectLoading class methodsFor: '*ole-public' stamp: 'lg 12/21/2007 13:32'!
openFromDirectory: dir andProjectName: projectName
        | directory aStream entries fileName |
        (Project named: projectName)
                ifNotNilDo: [:project | ^ project enter].
        directory := FileDirectory on: Smalltalk imagePath, FileDirectory slash, dir.
        entries := FileList2 projectOnlySelectionMethod: directory entries.
        entries := entries
                                detect: [:each | (Project parseProjectFileName: each first) first = projectName] ifNone: [^ false].
        fileName := entries first.
        self
                showProgressBarDuring: [ProgressNotification signal: '0'.
                        directory := FileDirectory on: Smalltalk imagePath, FileDirectory slash, dir.
                        aStream := directory readOnlyFileNamed: fileName.
                        self
                                openName: fileName
                                stream: aStream
                                fromDirectory: directory
                                withProjectView: #none]
! !

!ProjectLoading class methodsFor: '*ole-loading' stamp: 'lg 12/7/2007 10:44'!
openRecursivelyFromDirectory: dirName andProjectName: projectName 
	| dir |
	dir := FileDirectory on: dirName.
	(self openFromDirectory: dirName andProjectName: projectName)
		ifTrue: [^true]
		ifFalse: [dir directoryNames do:
			[:subdir | (self openRecursivelyFromDirectory: (dir fullPathFor: subdir) andProjectName: projectName) ifTrue: [^true]]].
	^false.! !

SketchMorph subclass: #FootBall
	instanceVariableNames: 'leftBlocked rightBlocked upBlocked downBlocked lastClicked'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!FootBall methodsFor: 'as yet unclassified' stamp: 'Ram 3/11/2008 16:31'!
displayQuestion
	World allMorphsDo:[:each| ((each isKindOf: SketchMorph) 
									and:['Envelop*' match: each externalName] 
									and:[self player overlapsAny: each player]
									)ifTrue:[Transcript show: each; cr.]
		
	]
! !

!FootBall methodsFor: 'accessing' stamp: 'Ram 3/11/2008 16:29'!
downBlocked
	"Answer the value of downBlocked"

	^ downBlocked! !

!FootBall methodsFor: 'accessing' stamp: 'Ram 3/11/2008 16:29'!
downBlocked: anObject
	"Set the value of downBlocked"

	downBlocked _ anObject! !

!FootBall methodsFor: 'as yet unclassified' stamp: 'Ram 4/15/2008 12:16'!
handleKeystroke: anEvent
	| keyValue |

	keyValue:= anEvent keyValue.
	keyValue= 30 "up arrow"
		ifTrue: [ (self  color: (Color r: 0.0 g: 0.0 b: 0.0) sees: (Color r: 1.0 g: 0.596 b: 0.0)) 
					ifFalse:[self position:  self position-(0@4).]
					ifTrue:[(self lastClicked='up') 
								ifTrue:[self position:  self position+(0@12).]
								ifFalse:[self moveAwayFromWall].
							].
					self lastClicked: 'up'.
				].
	keyValue= 31 "down arrow"
		ifTrue: [(self color: (Color r: 0.0 g: 0.0 b: 0.0) sees: (Color r: 1.0 g: 0.596 b: 0.0))
					ifFalse:[self position: self position+(0@4).]
					ifTrue:[(self lastClicked='down')
								ifTrue:[ self position: self position-(0@12).]
								ifFalse:[self moveAwayFromWall].
							].
					self lastClicked: 'down'.
				].
	keyValue= 29 "right arrow"
		ifTrue: [(self color: (Color r: 0.0 g: 0.0 b: 0.00) sees: (Color r: 1.0 g: 0.596 b: 0.0))
					ifFalse:[self position: self position+(4@0).]
					ifTrue:[(self lastClicked='right')
								ifTrue:[self position: self position-(12@0).]
								ifFalse:[self moveAwayFromWall].
							].
					self lastClicked: 'right'.
				].
	keyValue= 28 "left arrow"
		ifTrue: [(self color: (Color r: 0.0 g: 0.0 b: 0.00) sees: (Color r: 1.0 g: 0.596 b: 0.0))
					ifFalse:[self position: self position-(4@0).]
					ifTrue:[(self lastClicked='left')
								ifTrue:[self position: self position+(12@0).]
								ifFalse:[self moveAwayFromWall].
							].
					self lastClicked: 'left'.
				].

! !

!FootBall methodsFor: 'as yet unclassified' stamp: 'Ram 3/11/2008 16:31'!
handlesMouseDown:anEvent
^true! !

!FootBall methodsFor: 'as yet unclassified' stamp: 'Ram 3/11/2008 16:32'!
handlesMouseOver:anEvent
^true
! !

!FootBall methodsFor: 'accessing' stamp: 'Ram 3/11/2008 16:29'!
lastClicked
	"Answer the value of lastClicked"

	^ lastClicked! !

!FootBall methodsFor: 'accessing' stamp: 'Ram 3/11/2008 16:29'!
lastClicked: anObject
	"Set the value of lastClicked"

	lastClicked _ anObject! !

!FootBall methodsFor: 'accessing' stamp: 'Ram 3/11/2008 16:29'!
leftBlocked
	"Answer the value of leftBlocked"

	^ leftBlocked! !

!FootBall methodsFor: 'accessing' stamp: 'Ram 3/11/2008 16:29'!
leftBlocked: anObject
	"Set the value of leftBlocked"

	leftBlocked _ anObject! !

!FootBall methodsFor: 'as yet unclassified' stamp: 'Ram 3/11/2008 16:32'!
mouseDown:anEvent
	anEvent redButtonPressed! !

!FootBall methodsFor: 'as yet unclassified' stamp: 'Ram 3/11/2008 16:32'!
mouseEnter:anEvent
anEvent hand newKeyboardFocus: self! !

!FootBall methodsFor: 'as yet unclassified' stamp: 'Ram 3/11/2008 16:32'!
moveAwayFromWall
	 | lastMove |
	lastMove:= self lastClicked.
	lastMove ='up'ifTrue:[self position:  self position+(0@6)].
	lastMove ='down'ifTrue:[self position: self position-(0@6)].
	lastMove ='right'ifTrue:[self position: self position-(6@0)].
	lastMove ='left'ifTrue:[self position:  self position+(6@0)].
	! !

!FootBall methodsFor: 'as yet unclassified' stamp: 'Ram 3/11/2008 16:33'!
resetBlock
	self upBlocked:false.
	self downBlocked:false.
	self leftBlocked:false.
	self rightBlocked:false.

! !

!FootBall methodsFor: 'accessing' stamp: 'Ram 3/11/2008 16:29'!
rightBlocked
	"Answer the value of rightBlocked"

	^ rightBlocked! !

!FootBall methodsFor: 'accessing' stamp: 'Ram 3/11/2008 16:29'!
rightBlocked: anObject
	"Set the value of rightBlocked"

	rightBlocked _ anObject! !

!FootBall methodsFor: 'accessing' stamp: 'Ram 3/11/2008 16:29'!
upBlocked
	"Answer the value of upBlocked"

	^ upBlocked! !

!FootBall methodsFor: 'accessing' stamp: 'Ram 3/11/2008 16:29'!
upBlocked: anObject
	"Set the value of upBlocked"

	upBlocked _ anObject! !

SketchMorph subclass: #PicturePuzzlePieceMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!PicturePuzzlePieceMorph methodsFor: 'puzzle' stamp: 'lg 10/10/2007 15:34'!
justDroppedInto: morph event: evt
	super justDroppedInto: morph event: evt.
	(morph isKindOf: PicturePuzzleBlockMorph) ifTrue:
		[ morph submorphs do: [ :m | morph owner placeInEmptyBox: m ] without: self ].
	self beep: 'click'.
	(morph owner isKindOf: PicturePuzzleMorph) ifTrue:
		[ morph owner checkCompletion ].! !

!PicturePuzzlePieceMorph methodsFor: 'puzzle' stamp: 'lg 10/14/2007 12:34'!
label: string 
	| morph font |
	font := string asInteger isNil ifTrue: [((TextStyle named: #BitstreamVeraSansMono) fontOfPointSize: 32)]
							  ifFalse: [((TextStyle named: #DevanagariNew) fontOfPointSize: 36)].
	morph := StringMorph contents: string font: font.
	morph shadowOffset: 2@2.
	morph center: self center.
	morph color: (Color white darker); hasDropShadow: true; shadowColor: (Color black alpha: 0.75).
	self addMorph: morph.! !

SketchMorph subclass: #RestartButtonMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

SketchMorph subclass: #RippedOffMorph
	instanceVariableNames: 'target patch'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!RippedOffMorph methodsFor: 'initialization' stamp: 'lg 9/25/2007 11:21'!
justDroppedInto: morph event: evt
	super justDroppedInto: morph event: evt.
	morph == patch ifTrue: [self replacePatch: morph].! !

!RippedOffMorph methodsFor: '*ole' stamp: 'lg 9/25/2007 12:07'!
replacePatch: patchMorph
	target extent: patchMorph extent; position: patchMorph position.
	patch owner replaceSubmorph: patchMorph by: target.
	OLE congratulate.! !

!RippedOffMorph methodsFor: 'initialization' stamp: 'lg 9/25/2007 11:22'!
setPatch: morph 
	patch := morph.
! !

!RippedOffMorph methodsFor: 'initialization' stamp: 'lg 9/25/2007 10:26'!
setTarget: morph 
	target := morph.
	self form: target imageForm.! !

!SketchMorph methodsFor: '*ole-picturepuzzle' stamp: 'lg 10/10/2007 09:26'!
addCustomMenuItems: aCustomMenu hand: aHandMorph
	"Add custom menu items"

	super addCustomMenuItems: aCustomMenu hand: aHandMorph.
	aCustomMenu add: 'restore base graphic' translated target: self action: #restoreBaseGraphicFromMenu.
	aCustomMenu add: 'call this my base graphic' translated target: self action: #callThisBaseGraphic.
	aCustomMenu add: 'choose new graphic...' translated target: self action: #chooseNewGraphic.
	aCustomMenu addLine.
	aCustomMenu add: 'set as background' translated target: rotatedForm action: #setAsBackground.
	self addPaintingItemsTo: aCustomMenu hand: aHandMorph.
	self addPicturePuzzleItemsTo: aCustomMenu hand: aHandMorph.! !

!SketchMorph methodsFor: '*ole-picturepuzzle' stamp: 'lg 10/10/2007 09:30'!
addPicturePuzzleItemsTo: aCustomMenu hand: aHandMorph
	aCustomMenu addLine.
	aCustomMenu add: 'create picture puzzle morph' translated
					target: self action: #grabPicturePuzzleMorph.
	aCustomMenu add: 'create picture puzzle thumbnail' translated
					target: self action: #grabPicturePuzzleThumbnailMorph.
! !

!SketchMorph methodsFor: '*ole-picturepuzzle' stamp: 'lg 10/10/2007 09:31'!
grabPicturePuzzleMorph
	| morph |
	morph := self picturePuzzleMorph openInWorld.
	morph center: World activeHand center.
	World activeHand grabMorph: morph.! !

!SketchMorph methodsFor: '*ole-picturepuzzle' stamp: 'lg 10/10/2007 10:34'!
grabPicturePuzzleThumbnailMorph
	self picturePuzzleThumbnailMorph openInWorld grab.! !

!SketchMorph methodsFor: '*ole-picturepuzzle' stamp: 'lg 10/9/2007 20:20'!
picturePuzzleMorph
	^PicturePuzzleMorph new scrambleForm: self form! !

!SketchMorph methodsFor: '*ole-picturepuzzle' stamp: 'lg 10/10/2007 10:31'!
picturePuzzleThumbnailMorph
	^PicturePuzzleThumbnailMorph new makeThumbnailFromForm: self form.! !

ImageMorph subclass: #DisplayBoard
	instanceVariableNames: 'dispImage'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!DisplayBoard methodsFor: 'accessing - properties' stamp: 'Aayush 5/22/2008 16:52'!
dispImage
	^dispImage! !

!DisplayBoard methodsFor: 'accessing - properties' stamp: 'Aayush 5/22/2008 16:53'!
dispImage: anImageMorph
	dispImage:= anImageMorph! !

!DisplayBoard methodsFor: 'initialization' stamp: 'Aayush 5/22/2008 16:54'!
initialize
	super initialize.
	self dispImage: ImageMorph new.
	self addMorph: self dispImage.
	self dispImage center: self center.! !

ImageMorph subclass: #PicturePuzzleThumbnailMorph2
	instanceVariableNames: 'filename gridSize cache labels'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!PicturePuzzleThumbnailMorph2 class methodsFor: 'as yet unclassified' stamp: 'lg 10/16/2007 17:28'!
file: filename cache: flag
	^PicturePuzzleThumbnailMorph2 new setImageFile: filename cache: flag.! !

!PicturePuzzleThumbnailMorph2 methodsFor: 'as yet unclassified' stamp: 'lg 10/16/2007 17:21'!
handlesMouseDown: event
	^true! !

!PicturePuzzleThumbnailMorph2 methodsFor: 'as yet unclassified' stamp: 'lg 10/16/2007 11:05'!
initialize
	super initialize.
	gridSize := 4.! !

!PicturePuzzleThumbnailMorph2 methodsFor: 'as yet unclassified' stamp: 'lg 10/16/2007 17:08'!
loadFileIntoCache
	cache := (FileStream readOnlyFileNamed: filename) binary contents.! !

!PicturePuzzleThumbnailMorph2 methodsFor: 'as yet unclassified' stamp: 'lg 10/16/2007 17:10'!
loadForm
	^cache = nil ifTrue: [ImageReadWriter formFromFileNamed: filename] ifFalse: [ImageReadWriter formFromStream: cache readStream].! !

!PicturePuzzleThumbnailMorph2 methodsFor: 'as yet unclassified' stamp: 'lg 10/16/2007 17:21'!
mouseDown: event
	self openPuzzle.! !

!PicturePuzzleThumbnailMorph2 methodsFor: 'as yet unclassified' stamp: 'lg 10/16/2007 17:31'!
openPuzzle
	| morph |
	World allMorphsDo: [ :m | (m isKindOf: PicturePuzzleMorph) ifTrue: [m delete] ].
	morph := PicturePuzzleMorph new rows: gridSize; columns: gridSize.
	morph labels: (labels caseOf: { [nil] -> [ #() ].
							      [#letters] -> ['ABCDEFGHIJKLMNOPQRSTUVWXYZ' asArray collect: #asString].
							      [#numbers] -> [(1 to: 100) collect: #asString]}).
	morph scrambleForm: self loadForm.
	morph center: World center.
	morph top: 90.
	morph openInWorld! !

!PicturePuzzleThumbnailMorph2 methodsFor: 'as yet unclassified' stamp: 'lg 10/16/2007 17:14'!
setImageFile: aFilename cache: flag
	cache := nil.
	filename := aFilename.
	flag ifTrue: [self loadFileIntoCache].
	self showThumbnail.
! !

!PicturePuzzleThumbnailMorph2 methodsFor: 'as yet unclassified' stamp: 'lg 10/16/2007 17:14'!
setImageFile: aFilename
	self setImageFile: aFilename cache: false.! !

!PicturePuzzleThumbnailMorph2 methodsFor: 'as yet unclassified' stamp: 'lg 10/16/2007 11:00'!
showThumbnail
	self image: (self loadForm scaledToSize: 200@150).
! !

!SugarNavigatorBar methodsFor: '*ole-override' stamp: 'lg 12/20/2007 21:50'!
makeTheButtons

	^ Preferences useArtificialSweetenerBar
		ifTrue: [self makeTheSimpleButtonsSqueakland]
		ifFalse: [OLE isAuthorMode ifTrue: [self makeTheSimpleButtons] ifFalse: [self makeTheMinimalButtons]]
! !

!SugarNavigatorBar methodsFor: '*ole-override' stamp: 'lg 12/23/2007 20:45'!
makeTheMinimalButtons
	"Add the buttons for use in normal kids' mode."

	^((Project current parent isTopProject) ifTrue: [{}] ifFalse: [{self buttonPrev}]),
	(((DisplayScreen actualScreenSize = OLPCVirtualScreen virtualScreenExtent)
		ifFalse: [{#spacer. self buttonZoom}]
		ifTrue: [#()])),
	{	#spacer.
		self buttonStop.
		}
! !

SimpleButtonMorph subclass: #ScramblerMorph
	instanceVariableNames: 'gridSize'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!ScramblerMorph methodsFor: 'as yet unclassified' stamp: 'lg 10/11/2007 17:49'!
doButtonAction
	World allMorphsDo: [ :m | (m isKindOf: PicturePuzzleMorph) ifTrue:
								[ m rows: gridSize; columns: gridSize; rescramble ] ].! !

!ScramblerMorph methodsFor: 'as yet unclassified' stamp: 'lg 10/11/2007 17:45'!
drawOn: canvas
	| c p r blockWidth blockHeight |
	blockWidth := self width // gridSize.
	blockHeight := self height // gridSize.
	(0 to: gridSize-1) do: [ :row | (0 to: gridSize-1) do: [ :col |
		c := row+col \\ 2 = 0 ifTrue: [color] ifFalse: [Color white].
		p := self position + ((blockWidth*col) @ (blockHeight*row)).
		r := p corner: p + (blockWidth@blockHeight).
		canvas fillRectangle: r color: c
	]]! !

!ScramblerMorph methodsFor: 'as yet unclassified' stamp: 'lg 10/11/2007 17:45'!
initialize
	super initialize.
	self color: Color black.
	gridSize := 3.! !

!CostumizedBookMorph methodsFor: '*ole-game-element' stamp: 'a 3/6/2008 16:36'!
playPageFlipSound: soundName
	^self
! !

!Integer methodsFor: '*ole-sound' stamp: 'lg 10/4/2007 12:24'!
sayInNepali
	self beep: 'ne-' , self asWords.! !

!ProjectViewMorph methodsFor: '*ole' stamp: 'lg 10/13/2007 12:49'!
balloonText
	^nil.
! !

!ProjectViewMorph methodsFor: '*ole' stamp: 'lg 12/7/2007 11:18'!
setupDiskProxyUnderImage
	(project isKindOf: Project) ifTrue: [project := project setupDiskProxyUnderImage]! !
OLE initialize!
ProjectDirectoryMorph initialize!
